// $Id: cmdparse.h 14514 2011-09-23 15:14:24Z ps $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * Command line parser header file
 */

#ifndef _CMDPARSE_H_
#define _CMDPARSE_H_

#include <stdlib.h>

typedef struct {
  const char *option;
  const char *description;
  const char *descriptionShort;
  enum {
      OPTION_OPTIONAL,  //<-- Option is not required for app function
      OPTION_REQUIRED,  //<-- Option is required for app function
      OPTION_BOOLEAN    //<-- Option is a boolean defaulting to whatnot
      }  mode;
  enum {
      ARG_NONE,         //<-- There is no spoon
      ARG_STR,          //<-- The spoon is a string
      ARG_NUM           //<-- The spoon is a number
      } type;
  char **result;
} CommandLineOptions_t;

int InitApplication(int *argc, char *argv[], CommandLineOptions_t *app_options, char *app_description);

#endif
