// $Id: device.h 14206 2011-09-08 16:47:22Z ps $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * GetDevice header file
 */

#ifndef _DEVICE_H_
#define _DEVICE_H_

#ifndef WIN32
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <net/if.h>
#endif

#include <basetype.h> // handle_t

/* Device size. ie eth0. */
#define DEVICE_NAME_SIZE IFNAMSIZ
/* Possible modes. */
enum { PCAP_CAPTURE=1, NTCI_CAPTURE, NTCI_NT_ONLY};

int GetDevice(char *device, int mode, int showOnly);
int ParseDeviceName(char *deviceName);
char* GetVPDStringAdapterName(handle_t cardHandle);

#endif
