// $Id: AdapterBonding.c 4436 2009-02-23 11:42:11Z ps $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * This tool is a Napatech internal tool used by the load_driver script
 */

#ifdef WIN32
#include <Windows.h>
#include "platformwin.h"
#else
#include <ctype.h>
#include <string.h>
#include <stdarg.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <time.h>
#endif
#include <toolslib.h>

#include <cardconfigurationstructure.h>

int main(void)
{
  handle_t cardHandle;
  uint32_t result=0;
  AdapterPairConfigurationType1_t    adapterPairType1;

  cardHandle = NTCI_OpenCard(NTCI_ANY_NAPATECH_CARD_TYPE, 0);
  if(cardHandle != NULL) {    
    adapterPairType1.action = 1;
    result = NTCI_Command(cardHandle, STID_ADAPTER_PAIR_CONFIGURATION_TYPE1, &adapterPairType1);
    NTCI_CloseCard(cardHandle);
  }
  if(result==0) {
    return 0;
  } else {
    return -1; /* Error. */
  }
  return 0;
}

