// $Id: CardConfiguration.h 17628 2012-03-01 14:44:10Z mh $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * header file for CardConfiguration.c
 */

#ifndef _CARDCONFIGURATION_H_
#define _CARDCONFIGURATION_H_

typedef struct _timestampTypes_s {
  const char *Name;
  const char *Description;
  TimestampType_t TimestampType;
} timestampTypes_s;


uint32_t CardConfigMaxFrameSize(uint8_t card, uint32_t channelsBitmask, uint32_t maxFrameSize);
uint32_t CardConfigDecoderSet(uint8_t card, uint32_t channelsBitmask,
                              uint8_t decoderMode, uint32_t maxFrameSize,
                              uint8_t enableISL, uint8_t enableVLAN, uint8_t enableJUMBO, uint8_t enableMPLS,
                              uint8_t allowISLVLAN, uint8_t allowISLJUMBO, uint8_t allowJUMBOVLAN, uint8_t allowJUMBOMPLS,
                              uint8_t ISL64IsSmall, uint8_t VLAN64IsSmall);

uint32_t _CardConfigMaxFrameSize(void *arglist);
uint32_t _CardConfigDecoderSet(void *arglist);
uint32_t _CardConfigDecoderSet7(void *arglist);
uint32_t _CardConfigDecoderSet8(void *arglist);

uint32_t CardConfigPolicySet(uint8_t card, uint32_t feedIndex, uint32_t channelsBitmask,
                             uint32_t blockLevel, uint32_t policeLevel, uint32_t restartLevel, uint8_t enableLevels,
                             uint32_t chan0BucketSize, uint32_t chan0Bandwidth,
                             uint32_t chan1BucketSize, uint32_t chan1Bandwidth);
uint32_t _CardConfigPolicySet(void *arglist);

uint32_t GetAutonegotiationMode(uint8_t card, uint32_t channelBitmask);                                
uint32_t _GetAutonegotiationMode(void *arglist);
uint32_t SetAutonegotiationMode(uint8_t card, uint32_t channelBitmask,
                                uint8_t enable, uint8_t required, uint8_t restartAutoNeg,
                                uint8_t advertise10000FullDuplex, uint8_t	advertise10000HalfDuplex,
                                uint8_t	advertise1000FullDuplex, uint8_t	advertise1000HalfDuplex,
                                uint8_t	advertise100FullDuplex, uint8_t	advertise100HalfDuplex,
                                uint8_t	advertise10FullDuplex, uint8_t	advertise10HalfDuplex,
                                uint8_t pauseControlMode, uint8_t	manualFullDuplex,
                                uint8_t	manualSpeed, uint8_t mdiMode,
                                uint8_t setdefault);
uint32_t _SetAutonegotiationMode(void *arglist);

uint32_t _CardConfigTimeSync(void *arglist);
uint32_t CardConfigTimeSync(uint8_t card, char *action);

uint32_t _GetTimeSyncConfig(void *arglist);
uint32_t GetTimeSyncConfig(uint8_t card);

uint32_t _CardPrintTimestampConfig(void *arglist);
uint32_t CardPrintTimestampConfig(uint8_t card, uint8_t justSet);

uint32_t _CardSetTimestampOffsetConfig(void *arglist);
uint32_t CardSetTimestampOffsetConfig(uint8_t card, uint32_t cablelength, uint32_t numberofgpsboxes);

uint32_t _CardSetTimestampConfig(void *arglist);
uint32_t CardSetTimestampConfig(uint8_t card, char *timestampType, uint64_t value);

uint32_t _CardConfigFailover(void *arglist);
uint32_t CardConfigFailover(uint8_t card, char *action);

uint32_t _FailoverHeartbeatSignal(void *arglist);
uint32_t FailoverHeartbeatSignal(uint8_t card);

uint32_t _CardSetTemperatureThreshold(void *arglist);
uint32_t CardSetTemperatureThreshold(uint8_t card, char *sensor, char *highOrLow, uint32_t value);

uint32_t SetPortIdentificationStatus(uint8_t card, uint32_t channelMask, uint32_t enable);
uint32_t GetPortIdentificationStatus(uint8_t card, uint32_t channelMask);

#endif
