// $Id: Statistics.h 6259 2009-11-17 12:03:25Z ph $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * Statistics.c header file
 */

#ifndef _STATISTICS_H_
#define _STATISTICS_H_
uint32_t StatisticsStart(uint8_t card, uint32_t channelsBitmask);
uint32_t StatisticsStop(uint8_t card, uint32_t channelsStatistics);
uint32_t StatisticsReset(uint8_t card, uint32_t channelsBitmask);
uint32_t StatisticsGetSummary(uint8_t card, uint32_t channelBitmask, bool_t RxStat);
uint32_t StatisticsGetRMONCounters(uint8_t card, uint32_t channelsBitmask, bool_t hex, bool_t RxStat);
uint32_t StatisticsGetType2Counters(uint8_t card, uint32_t channelsBitmask, bool_t hex);
uint32_t StatisticsGetHwCounters(uint8_t card, uint32_t channelsBitmask, bool_t hex, bool_t RxStat);
uint32_t StatisticsGetBlockCounters(uint8_t card,
                                    uint32_t channelsBitmask,
                                    uint64_t colorsBitmask,
                                    uint32_t feedsBitmask,
                                    uint8_t  summary, bool_t hex);


uint32_t _StatisticsStart(void *);
uint32_t _StatisticsStop(void *);
uint32_t _StatisticsReset(void *);
uint32_t _StatisticsGetSummary(void *);
uint32_t _StatisticsGetRMONCounters(void *);
uint32_t _StatisticsGetHwCounters(void *);
uint32_t _StatisticsGetTxSummary(void *);
uint32_t _StatisticsGetTxRMONCounters(void *);
uint32_t _StatisticsGetTxHwCounters(void *);
uint32_t _StatisticsGetBlockCounters(void *);
uint32_t _StatisticsGetType2Counters(void *);
#endif



