// $Id: NTCI_capabilities.h 16051 2011-11-30 12:20:27Z ps $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * C functions to access the driver interface Card Capabilities
 */

#ifndef __NTCI_CAPABILITIES_H__
#define __NTCI_CAPABILITIES_H__

#include "NTCommonInterface.h"

#define NTCI_STATUSCODE_CAPABILITY_NOT_FOUND        20

/*-----------------------------------------------------------------------------
 * The following function is used to retrieve capability structures from
 * the capabilities tree. See "capabilitiesstructure.h" for details on
 * how the capabilities tree is structured etc.
 *---------------------------------------------------------------------------*/
NTCOMMONLIB uint32_t NTCOMMONCALL       /* Return code (status/error).       */
NTCI_GetCapabilities(
  IN  handle_t    hCard,                /* Pointer to the cardhandle provided by the NTCI_OpenCard call. */
  IN  uint32_t    capabilitiesId,       /* Parent of the requested structId. */
  IN  uint8_t     subCapabilitiesIndex, /* If the parent node has index capability this will be used to select which index to retrieve. */
  IN  StructureID structId,             /* The structure ID of the structure to retrieve. */
  OUT void *      data);                /* A pointer to the destination structure. */

#endif // __NTCI_CAPABILITIES_H__
