// $Id: NTCI_devicecontrol.h 16051 2011-11-30 12:20:27Z ps $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * C functions to access the driver interface Device Control.
 */

#ifndef __NTCI_DEVICECONTROL_H__
#define __NTCI_DEVICECONTROL_H__

#include "NTCommonInterface.h"
#include "devicecontrolstructure.h"

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_ProgramDevice(IN handle_t     hCard,
                                                     IN  uint32_t    deviceId,
                                                     IN  void *      deviceImage,
                                                     IN  uint32_t    deviceImageSize,
                                                     IN  uint32_t    programFlags );

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_ImageUpload(IN handle_t    hCard,
                                                   IN StructureID structid,
                                                   IN void        *pDeviceControl);  

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_DeviceControl(IN handle_t    hCard,
                                                     IN StructureID structid,
                                                     IN void        *pDeviceControl);  

#endif // __NTCI_DEVICECONTROL_H__
