// $Id: NTCI_worklist.h 15098 2011-10-24 12:44:02Z aa $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * C functions to access the worklist interface.
 */

#ifndef __NTCI_WORKLIST_H__
#define __NTCI_WORKLIST_H__

#include "NTCommonInterface.h"
#include "workliststructure.h"

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_CreateWorklist(
  uint32_t         IN  worklistIndex,
  StructureID      IN  idWorklistConfig,
  void             IN  *pWorklistConfig,
  WorklistHandle_t OUT *pWorklistHandle);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_DestroyWorklist(
  WorklistHandle_t IN  worklistHandle);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_GetNextWorklistBuffer(
  WorklistHandle_t IN  worklistHandle,
  StructureID      IN  idBufferRequest,
  void             IN  *pBufferRequest,
  StructureID      IN  idBufferInformation,
  void             OUT *pBufferInformation);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_ReleaseWorklistBuffer(
  WorklistHandle_t IN  worklistHandle,
  StructureID      IN  idBufferInformation,
  void             IN  *pBufferInformation);

#endif // __NTCI_WORKLIST_H__
