
#ifndef NT_LEGACY_4_25

#ifndef DEPRECATED_4_25
#warning: This file was part of a Xyratex specific framework and has been retired.
#warning: It is not and has never been required for Napatech Adapter operations.
#warning: Please remove this file from your project and recompile.
#warning: See file /include/xyratex_retired_readme.txt for more information.
#endif

#else //NT_LEGACY_4_25
#ifndef  __INCLUDED_EXTENDEDDESCRIPTOR00_H__
#define  __INCLUDED_EXTENDEDDESCRIPTOR00_H__

#include "basetype.h"

#include "ntpackpush.h"

#ifdef __cplusplus 
extern "C" {
#endif

#define EXTENDED_DESCRIPTOR_00_KNOWN

/* Uncomment the following line to enable the debug display function */
/*#define EXTENDED_DESCRIPTOR_00_DISPLAY(s,t) ext00_CheckNDisplayContents(s,t)*/


/* The following are the values to use with CreatePacketFeed in order to request this
    full extended descriptor*/

/* The following definitions should be used when creating a packet feed with one of the
	'FeedConfigSampledType' structures
  For creating a feed with this structure you need to set the 'descriptorType' (if applicable)
   to EXTENDED_DESCRIPTOR
  Use the following with the 'extendedDescriptorFormat' attribute */
#define EXTENDED_DESCRIPTOR_00_TYPE	0x00
/* Use the following with the 'extendedDescriptorLength' attribute 
    The extension length is 5x64bits, you can choose reduce the etended length by
    multiples of 64-bits -  note you will have to handle the structure overlay correctly*/
#define EXTENDED_DESCRIPTOR_00_LENGTH	(6)

/* Use the following with the 'extendedDescriptorConfig' attribute if applicable */
#define EXTENDED_DESCRIPTOR_08_CONFIG 0x00b


/*
** This is the extended frame descriptor.  The frame data follows this extended descriptor.
** NOTE that the position of the frame data following this descriptor will be dependent on the
**  length of the extended descriptor requested.
*/
typedef struct tagPacketExtDescriptorType00
{
	uint64_t GroupMatch;					/* 1 bit per Group Match Filter Definition, each of the 64 group matches will cause the appropriate
												bit to be set in this field if this match triggers a group match */

	uint32_t Layer2Encapsulation:4;			/* ext00_Layer2EncapsulationType_t */
	uint32_t Layer2Protocol:2;				/* ext00_Layer2ProtocolType_t */
	uint32_t Layer2AddressType:2;			/* ext00_Layer2AddressType_t */
	uint32_t Layer2HeaderOffset:8;			/* Offset in bytes to the Layer 2 Header (MAC Address) - compensates for encapsulation */

	uint32_t Layer3Protocol:4;				/* ext00_Layer3ProtocolType_t */
	uint32_t MACAddressSwap:1;              /* Indicates that the destination MAC address is a greater value than the source MAC address */
	uint32_t Reserved:1;
	uint32_t Layer3IPv4Checksum:2;			/* ext00_ChecksumType_t */
	uint32_t Layer3HeaderOffset:8;			/* Offset in bytes to the Layer 3 Header (IP, IPX, ...) - compensates for encapsulation */

	uint32_t Layer4Protocol:4;				/* ext00_Layer4ProtocolType_t */
	uint32_t IPFragmentation:2;				/* Indicates that the frame is part of a fragmented packet ext00_Layer4FragmentType_t */
	uint32_t Layer4IPv4Checksum:2;			/* ext00_ChecksumType_t */
	uint32_t Layer4HeaderOffset:8;			/* Offset in bytes to the Layer 4 Header (TCP, UDP, ...) - compensates for IP Header Options 
												For an IPv4 frame then this is valid on the FIRST frame of a fragmented IP frame or non
												fragmented frame */

    uint32_t HashAValid:1;                  /* HashA calculation is valid */
    uint32_t HashBValid:1;                  /* HashB calculation is valid */
	uint32_t Reserved2:2;               
	uint32_t IPAddressSwap:1;               /* If set the destination address is greater than the source address */
	uint32_t Reserved3:3;
	uint32_t HighLayerOffset:8;			    /* Offset in bytes to higher layer TCP/UDP Data - Compensates for TCP/UDP Headers (if present) */

	uint32_t IPv4DestAddress;				/* If the packet is a valid IPv4 packet then this field contains the destination address 
												otherwise this field is not valid*/
	uint32_t IPv4SourceAddress;				/* If the packet is a valid IPv4 packet then this field contains the source address
												otherwise this field is not valid*/

	uint32_t ProtocolFunction:8;			/* 1 bit per Protocol Filter Definition, each of the 8 protocol matches will cause the appropriate
												bit to be set in this field if this match triggers a protocol match */
	uint32_t ErrorFunction:8;				/* 1 bit per Error Filter Definition, each of the 8 error matches will cause the appropriate
												bit to be set in this field if this match triggers a error match */
	uint32_t SizeFunction:2;
	uint32_t Reserved4:6;
	uint32_t CAMFunction:2;
	uint32_t Reserved5:6;

	uint32_t TCPUDPDestPort:16;				/* If the packet is a valid IPv4 TCP/UDPpacket then this field contains the destination port
												otherwise this field is not valid*/
	uint32_t TCPUDPSourcePort:16;			/* If the packet is a valid IPv4 TCP/UDP packet then this field contains the source port
												otherwise this field is not valid*/

	uint64_t PatternMatch;					/* 1 bit per Pattern Match Filter Definition, each of the 64 pattern matches will cause the appropriate
												bit to be set in this field if this match triggers a pattern match */

    uint32_t HashA;                         /* Hash caclulation on IP address and port pairs */
    uint32_t HashB;   
} PacketExtDescriptorType00_t;

/* Layer2 Encapsulation Type is a bitwise field, thus more 
   than one bit may be set at any one time */
typedef enum
{
	EXT00_VLAN	    = 1,
  EXT00_MPLS      = 2,
	EXT00_ISL	      = 4,
} ext00_Layer2EncapsulationType_t;

typedef enum
{
	EXT00_EII	= 0,
	EXT00_LLC   = 1,
	EXT00_SNAP	= 2,
	EXT00_RAW   = 3,
} ext00_Layer2ProtocolType_t;

typedef enum
{
	EXT00_UNICAST	= 0,
	EXT00_MULTICAST = 1,
	EXT00_BROADCAST	= 2,
} ext00_Layer2AddressType_t;

typedef enum
{
	EXT00_OTHER	= 0,
	EXT00_IPv4  = 1,
	EXT00_IPv6	= 2,
	EXT00_IPX   = 3,
	EXT00_ARP   = 4,
} ext00_Layer3ProtocolType_t;

typedef enum
{
	EXT00_CHKSUM_NOT_CHECKED = 0,
	EXT00_CHKSUM_GOOD        = 1,
	EXT00_CHKSUM_BAD	     = 2,
} ext00_ChecksumType_t;

typedef enum
{
	EXT00_TCP   = 1,
	EXT00_UDP	= 2,
	EXT00_ICMP  = 3,
} ext00_Layer4ProtocolType_t;

typedef enum
{
	EXT00_NO_FRAGMENT    = 0,
	EXT00_FIRST_FRAGMENT = 1,
	EXT00_FRAGMENT       = 2,
	EXT00_LAST_FRAGMENT  = 3,
} ext00_Layer4FragmentType_t;

/* --------------------------------------------------------------- */
/* Debug display to verify the contents of the extended descriptor */

#ifdef EXTENDED_DESCRIPTOR_00_DISPLAY
static void ext00_DisplayContents(void* data)
{
	PacketExtDescriptorType00_t* descriptorData = (PacketExtDescriptorType00_t*)data;
	uint8_t*	sourceAddress = (uint8_t*)&descriptorData->IPv4SourceAddress;
	uint8_t*	destAddress = (uint8_t*)&descriptorData->IPv4DestAddress;

	printf( "-------------------------\n");
	printf( "GroupMatch               : 0x%X\n", descriptorData->GroupMatch );
	printf( "Layer2Encapsulation      : " );
		switch(descriptorData->Layer2Encapsulation)
		{
			case EXT00_VLAN: printf("VLAN\n"); break;
			case EXT00_ISL: printf("ISL\n"); break;
			default: printf("Other\n"); break;
		}	
	printf( "Layer2Protocol           : " );
		switch(descriptorData->Layer2Protocol)
		{
			case EXT00_EII: printf("EII\n"); break;
			case EXT00_LLC: printf("LLC\n"); break;
			case EXT00_SNAP: printf("SNAP\n"); break;
			case EXT00_RAW: printf("Raw\n"); break;
			default: printf("Other\n"); break;
		}	
	printf( "Layer2AddressType        : " );
		switch(descriptorData->Layer2AddressType)
		{
			case EXT00_UNICAST: printf("Unicast\n"); break;
			case EXT00_MULTICAST: printf("Multicast\n"); break;
			case EXT00_BROADCAST: printf("Broadcst\n"); break;
			default: printf("Other\n"); break;
		}	
	printf( "MACAddress swap flag     : " );
	    if(descriptorData->MACAddressSwap == 1)
	    {
	        printf( "Set\n" );
	    }
	    else
	    {
	        printf( "Not set\n" );
	    }
	printf( "Layer2HeaderOffset       : %d\n", descriptorData->Layer2HeaderOffset );
	printf( "Layer3Protocol           : ");
		switch(descriptorData->Layer3Protocol)
		{
			case EXT00_IPv4: printf("IPv4\n"); break;
			case EXT00_IPv6: printf("IPv6\n"); break;
			case EXT00_IPX: printf("IPX\n"); break;
			case EXT00_ARP: printf("ARP\n"); break;
			default: printf("Other\n"); break;
		}	
	printf( "Layer3IPv4Checksum       : " );
		switch(descriptorData->Layer3IPv4Checksum)
		{
			case EXT00_CHKSUM_NOT_CHECKED: printf("Not checked\n"); break;
			case EXT00_CHKSUM_GOOD: printf("GOOD\n"); break;
			case EXT00_CHKSUM_BAD: printf("BAD\n"); break;
			default: printf("NA\n"); break;
		}	
	printf( "Layer3HeaderOffset       : %d\n", descriptorData->Layer3HeaderOffset );
	printf( "Layer4Protocol           : " );
		switch(descriptorData->Layer4Protocol)
		{
			case EXT00_TCP: printf("TCP\n"); break;
			case EXT00_UDP: printf("UDP\n"); break;
			case EXT00_ICMP: printf("ICMP\n"); break;
			default: printf("Other\n"); break;
		}	
        printf( "IPv4 Fragmentation       : " );
		switch(descriptorData->IPFragmentation)
		{
			case EXT00_FIRST_FRAGMENT: printf("First fragment\n"); break;
			case EXT00_FRAGMENT: printf("Fragment\n"); break;
			case EXT00_LAST_FRAGMENT: printf("Last fragment\n"); break;
			default: printf("Not fragmented\n"); break;
		}	
	printf( "Layer4IPv4Checksum       : " );
		switch(descriptorData->Layer4IPv4Checksum)
		{
			case EXT00_CHKSUM_NOT_CHECKED: printf("Not checked\n"); break;
			case EXT00_CHKSUM_GOOD: printf("GOOD\n"); break;
			case EXT00_CHKSUM_BAD: printf("BAD\n"); break;
			default: printf("NA\n"); break;
		}	
	printf( "Layer4HeaderOffset       : %d\n", descriptorData->Layer4HeaderOffset );
	printf( "HighLayerOffset          : %d\n", descriptorData->HighLayerOffset );
	printf( "IPv4DestAddress          : %d.%d.%d.%d\n"	, destAddress[3], destAddress[2]
														, destAddress[1], destAddress[0]);
	printf( "IPv4SourceAddress        : %d.%d.%d.%d\n"	, sourceAddress[3], sourceAddress[2]
														, sourceAddress[1], sourceAddress[0]);
        printf( "IPAddress swap flag      : " );
	    if(descriptorData->IPAddressSwap == 1)
	    {
	        printf( "Set\n" );
	    }
	    else
	    {
	        printf( "Not set\n" );
	    }
	printf( "ProtocolFunction         : 0x%X\n", descriptorData->ProtocolFunction );
	printf( "ErrorFunction            : 0x%X\n", descriptorData->ErrorFunction );
	printf( "SizeFunction             : 0x%X\n", descriptorData->SizeFunction );
	printf( "TCPUDPDestPort           : %d\n",   descriptorData->TCPUDPDestPort );
	printf( "TCPUDPSourcePort         : %d\n",   descriptorData->TCPUDPSourcePort );
	printf( "PatternMatch             : 0x%X\n", descriptorData->PatternMatch );
	printf( "HashA                    : 0x%4x - ", descriptorData->HashA );
	    if(descriptorData->HashAValid == 1)
		{
		    printf( "valid\n" );
		}
		else
		{
		    printf( "not valid\n" );
		}
	printf( "HashB                    : 0x%4x - ", descriptorData->HashB );
	    if(descriptorData->HashBValid == 1)
		{
		    printf( "valid\n" );
		}
		else
		{
		    printf( "not valid\n" );
		}
	printf( "-------------------------\n");
}

static void ext00_CheckNDisplayContents(int type, void* data)
{
	if (type == EXTENDED_DESCRIPTOR_00_TYPE)
	{
		ext00_DisplayContents(data);
	}
}
#endif

#ifdef __cplusplus 
}
#endif

#include "ntpackpop.h"

#endif /* __INCLUDED_CUSTOMDESCRIPTOR00_H__ */
#endif //NT_LEGACY_4_25
