
#ifndef NT_LEGACY_4_25

#ifndef DEPRECATED_4_25
#warning: This file was part of a Xyratex specific framework and has been retired.
#warning: It is not and has never been required for Napatech Adapter operations.
#warning: Please remove this file from your project and recompile.
#warning: See file /include/xyratex_retired_readme.txt for more information.
#endif

#else //NT_LEGACY_4_25
#ifndef  __INCLUDED_EXTENDEDDESCRIPTOR04_H__
#define  __INCLUDED_EXTENDEDDESCRIPTOR04_H__

#include "basetype.h"

#include "ntpackpush.h"

#ifdef __cplusplus 
extern "C" {
#endif

#define EXTENDED_DESCRIPTOR_04_KNOWN

/* Uncomment the following line to enable the debug display function */
/*#define EXTENDED_DESCRIPTOR_04_DISPLAY(s,t) ext04_CheckNDisplayContents(s,t)*/


/* The following are the values to use with CreatePacketFeed in order to request this
    full extended descriptor*/

/* The following definitions should be used when creating a packet feed with one of the
	'FeedConfigSampledType' structures
  For creating a feed with this structure you need to set the 'descriptorType' (if applicable)
   to EXTENDED_DESCRIPTOR
  Use the following with the 'extendedDescriptorFormat' attribute */
#define EXTENDED_DESCRIPTOR_04_TYPE	0x04
/* Use the following with the 'extendedDescriptorLength' attribute 
    The extension length is 4x64bits, you can choose reduce the etended length by
    multiples of 64-bits -  note you will have to handle the structure overlay correctly*/
#define EXTENDED_DESCRIPTOR_04_LENGTH	(4)

/* Use the following with the 'extendedDescriptorConfig' attribute if applicable */
#define EXTENDED_DESCRIPTOR_04_CONFIG 0x049


/*
** This is the extended frame descriptor.  The frame data follows this extended descriptor.
** NOTE that the position of the frame data following this descriptor will be dependent on the
**  length of the extended descriptor requested.
*/
typedef struct tagPacketExtDescriptorType04
{
    uint32_t MatchID:16;                    /* Indicates the address within the hardware table for a matching entry */
    uint32_t Match:1;                       /* Indicates this packet is matched in the hardware table at least once */
    uint32_t MultiMatch:1;                  /* Indicates this packet is matched in the hardware table more than once */
    uint32_t LUTContents:2;                 /* Indicates the contents of the associative look up table at address
                                               corresponding to the matching hardware table entry (1st pattern in pattern match mode) */
    uint32_t Reserved4:4;
    uint32_t NumMatchSearches:4;            /* In free pattern match mode this field indicates the number of
                                               pattern matches (each being a possible multiple table entry match) that were detected
                                               during the packet */
    uint32_t Reserved5:4;

    uint32_t MatchPosition:14;              /* The location in the packet of the first matching pattern for pattern match mode.
                                                Offset in bytes relative to the beginning of the TCP/UDP data region. */
    uint32_t Reserverd6:2;
    uint32_t IPv4HeaderSizeErr:1;           /* IPv4 header length <5 bytes */
    uint32_t IPv4HeaderTruc:1;              /* IPv4 header was trucated.The packet was not large enough to contain the whole header
                                               based on the header length field in the IPv4 packet header */
    uint32_t IPv4Truc:1;                    /* This bit indicates the IPv4 packet was truncated.
                                               The packet was not large enough to contain the IP packet based on the 'total length'
                                               field in the IPv4 packet header */
    uint32_t SrcIPAddrEqDest:1;             /* The Source and Destinateion IPv4 addresses are identical */
    uint32_t IPv4TTLeqz:1;                  /* IPv4 TTL field is set to '0' */
    uint32_t IPv4FlagsMD:1;                 /* Both the Don't Fragment and More Fragment bits are set within
                                               the IPv4 header flags field.*/
    uint32_t IPv4FlagsR:1;                  /* Reserved bit is set within the IPv4 header flags field. */
    uint32_t Reserved7:1;
    uint32_t TCPHdrTruc:1;                  /* TCP header was truncated.  The packet was not large enough to
                                               contain the whole header based on the header length field in the TCP packet header.*/
    uint32_t Reserved8:3;
    uint32_t TCPFlagXmasTree:1;             /* TCP header flags field had the URG, PUSH and FIN flags set. */
    uint32_t TCPFlagNULL:1;                 /* TCP header flags field had no flags set i.e. set to 0. */
    uint32_t Reserved9:2;

    uint32_t HashA;                         /* Hash calculation on IP Protocol, IPv4 address and tcp/udp port pairs - bi-dir flows*/
    uint32_t HashB;                         /* Hash calculation on IP Protocol, IPv4 address and tcp/udp port pairs - uni-dir flows*/

    uint32_t Layer2Encapsulation:4;         /* ext04_Layer2EncapsulationType_t */
    uint32_t Layer2Protocol:2;              /* ext04_Layer2ProtocolType_t */
    uint32_t Layer2AddressType:2;           /* ext04_Layer2AddressType_t */
    uint32_t Layer2HeaderOffset:8;          /* Offset in bytes to the Layer 2 Header (MAC Address) - compensates for encapsulation */
    uint32_t Layer3Protocol:4;              /* ext04_Layer3ProtocolType_t */
    uint32_t MACAddressSwap:1;              /* Indicates that the destination MAC address is a greater value than the source MAC address */
    uint32_t Reserved:1;
    uint32_t Layer3IPv4Checksum:2;          /* ext04_ChecksumType_t */
    uint32_t Layer3HeaderOffset:8;          /* Offset in bytes to the Layer 3 Header (IP, IPX, ...) - compensates for encapsulation */

    uint32_t Layer4Protocol:4;              /* ext04_Layer4ProtocolType_t */
    uint32_t IPFragmentation:2;             /* Indicates that the frame is part of a fragmented packet ext04_Layer4FragmentType_t */
    uint32_t Layer4IPv4Checksum:2;          /* ext04_ChecksumType_t */
    uint32_t Layer4HeaderOffset:8;          /* Offset in bytes to the Layer 4 Header (TCP, UDP, ...) - compensates for IP Header Options
                                               For an IPv4 frame then this is valid on the FIRST frame of a fragmented IP frame or non
                                               fragmented frame */
    uint32_t HashAValid:1;                  /* HashA calculation is valid */
    uint32_t HashBValid:1;                  /* HashB calculation is valid */
    uint32_t Reserved2:2;
    uint32_t IPAddressSwap:1;               /* If set the destination address is greater than the source address */
    uint32_t Reserved3:3;
    uint32_t HighLayerOffset:8;             /* Offset in bytes to higher layer TCP/UDP Data - Compensates for TCP/UDP Headers (if present) */

    uint64_t GroupMatch;                    /* 1 bit per Group Match Filter Definition, each of the 64 group matches will cause the appropriate
                                               bit to be set in this field if this match triggers a group match */
} PacketExtDescriptorType04_t;

/* Layer2 Encapsulation Type is a bitwise field, thus more 
   than one bit may be set at any one time */
typedef enum
{
    EXT04_VLAN      = 1,
    EXT04_MPLS      = 2,
    EXT04_ISL       = 4,
} ext04_Layer2EncapsulationType_t;

typedef enum
{
	EXT04_EII	= 0,
	EXT04_LLC   = 1,
	EXT04_SNAP	= 2,
	EXT04_RAW   = 3,
} ext04_Layer2ProtocolType_t;

typedef enum
{
	EXT04_UNICAST	= 0,
	EXT04_MULTICAST = 1,
	EXT04_BROADCAST	= 2,
} ext04_Layer2AddressType_t;

typedef enum
{
	EXT04_OTHER	= 0,
	EXT04_IPv4  = 1,
	EXT04_IPv6	= 2,
	EXT04_IPX   = 3,
	EXT04_ARP   = 4,
} ext04_Layer3ProtocolType_t;

typedef enum
{
	EXT04_CHKSUM_NOT_CHECKED = 0,
	EXT04_CHKSUM_GOOD        = 1,
	EXT04_CHKSUM_BAD	     = 2,
} ext04_ChecksumType_t;

typedef enum
{
	EXT04_TCP   = 1,
	EXT04_UDP	= 2,
	EXT04_ICMP  = 3,
} ext04_Layer4ProtocolType_t;

typedef enum
{
	EXT04_NO_FRAGMENT    = 0,
	EXT04_FIRST_FRAGMENT = 1,
	EXT04_FRAGMENT       = 2,
	EXT04_LAST_FRAGMENT  = 3,
} ext04_Layer4FragmentType_t;

/* --------------------------------------------------------------- */
/* Debug display to verify the contents of the extended descriptor */

#ifdef EXTENDED_DESCRIPTOR_04_DISPLAY
static void ext04_DisplayContents(void* data)
{
	PacketExtDescriptorType04_t* descriptorData = (PacketExtDescriptorType04_t*)data;

	printf( "-------------------------\n");

	printf( "NumMatchSearches         : %d\n", descriptorData->NumMatchSearches );
	printf( "LUTContents              : %d\n", descriptorData->LUTContents );
	printf( "MultiMatch               : %s\n", descriptorData->MultiMatch?"Yes":"No" );
	printf( "Match                    : %s\n", descriptorData->Match?"Yes":"No" );
	printf( "MatchID                  : %d\n", descriptorData->MatchID );
	printf( "TCPFlagXmasNULL          : %s\n", descriptorData->TCPFlagXmasNULL?"Yes":"No" );
	printf( "TCPFlagXmasTree          : %s\n", descriptorData->TCPFlagXmasTree?"Yes":"No" );
	printf( "TCPHdrTruc               : %s\n", descriptorData->TCPHdrTruc?"Yes":"No" );
	printf( "IPv4FlagsR               : %s\n", descriptorData->IPv4FlagsR?"Yes":"No" );
	printf( "IPv4FlagsMD              : %s\n", descriptorData->IPv4FlagsMD?"Yes":"No" );
	printf( "IPv4TTLeqz               : %s\n", descriptorData->IPv4TTLeqz?"Yes":"No" );
	printf( "SrcIPAddrEqDest          : %s\n", descriptorData->SrcIPAddrEqDest?"Yes":"No" );
	printf( "IPv4Truc                 : %s\n", descriptorData->IPv4Truc?"Yes":"No" );
	printf( "IPv4HeaderTruc           : %s\n", descriptorData->IPv4HeaderTruc?"Yes":"No" );
	printf( "IPv4HeaderSizeErr        : %s\n", descriptorData->IPv4HeaderSizeErr?"Yes":"No" );
	printf( "MatchPosition            : %d\n", descriptorData->MatchPosition );

	printf( "GroupMatch               : 0x%X\n", descriptorData->GroupMatch );
	printf( "Layer2Encapsulation      : " );
		switch(descriptorData->Layer2Encapsulation)
		{
			case EXT04_VLAN: printf("VLAN\n"); break;
			case EXT04_ISL: printf("ISL\n"); break;
			default: printf("Other\n"); break;
		}	
	printf( "Layer2Protocol           : " );
		switch(descriptorData->Layer2Protocol)
		{
			case EXT04_EII: printf("EII\n"); break;
			case EXT04_LLC: printf("LLC\n"); break;
			case EXT04_SNAP: printf("SNAP\n"); break;
			case EXT04_RAW: printf("Raw\n"); break;
			default: printf("Other\n"); break;
		}	
	printf( "Layer2AddressType        : " );
		switch(descriptorData->Layer2AddressType)
		{
			case EXT04_UNICAST: printf("Unicast\n"); break;
			case EXT04_MULTICAST: printf("Multicast\n"); break;
			case EXT04_BROADCAST: printf("Broadcst\n"); break;
			default: printf("Other\n"); break;
		}	
	printf( "MACAddress swap flag     : " );
	    if(descriptorData->MACAddressSwap == 1)
	    {
	        printf( "Set\n" );
	    }
	    else
	    {
	        printf( "Not set\n" );
	    }
	printf( "Layer2HeaderOffset       : %d\n", descriptorData->Layer2HeaderOffset );
	printf( "Layer3Protocol           : ");
		switch(descriptorData->Layer3Protocol)
		{
			case EXT04_IPv4: printf("IPv4\n"); break;
			case EXT04_IPv6: printf("IPv6\n"); break;
			case EXT04_IPX: printf("IPX\n"); break;
			case EXT04_ARP: printf("ARP\n"); break;
			default: printf("Other\n"); break;
		}	
	printf( "Layer3IPv4Checksum       : " );
		switch(descriptorData->Layer3IPv4Checksum)
		{
			case EXT04_CHKSUM_NOT_CHECKED: printf("Not checked\n"); break;
			case EXT04_CHKSUM_GOOD: printf("GOOD\n"); break;
			case EXT04_CHKSUM_BAD: printf("BAD\n"); break;
			default: printf("NA\n"); break;
		}	
	printf( "Layer3HeaderOffset       : %d\n", descriptorData->Layer3HeaderOffset );
	printf( "Layer4Protocol           : " );
		switch(descriptorData->Layer4Protocol)
		{
			case EXT04_TCP: printf("TCP\n"); break;
			case EXT04_UDP: printf("UDP\n"); break;
			case EXT04_ICMP: printf("ICMP\n"); break;
			default: printf("Other\n"); break;
		}	
        printf( "IPv4 Fragmentation       : " );
		switch(descriptorData->IPFragmentation)
		{
			case EXT04_FIRST_FRAGMENT: printf("First fragment\n"); break;
			case EXT04_FRAGMENT: printf("Fragment\n"); break;
			case EXT04_LAST_FRAGMENT: printf("Last fragment\n"); break;
			default: printf("Not fragmented\n"); break;
		}	
	printf( "Layer4IPv4Checksum       : " );
		switch(descriptorData->Layer4IPv4Checksum)
		{
			case EXT04_CHKSUM_NOT_CHECKED: printf("Not checked\n"); break;
			case EXT04_CHKSUM_GOOD: printf("GOOD\n"); break;
			case EXT04_CHKSUM_BAD: printf("BAD\n"); break;
			default: printf("NA\n"); break;
		}	
	printf( "Layer4HeaderOffset       : %d\n", descriptorData->Layer4HeaderOffset );
	printf( "HighLayerOffset          : %d\n", descriptorData->HighLayerOffset );
    printf( "IPAddress swap flag      : " );
	    if(descriptorData->IPAddressSwap == 1)
	    {
	        printf( "Set\n" );
	    }
	    else
	    {
	        printf( "Not set\n" );
	    }
	printf( "HashA                    : 0x%4x - ", descriptorData->HashA );
	    if(descriptorData->HashAValid == 1)
		{
		    printf( "valid\n" );
		}
		else
		{
		    printf( "not valid\n" );
		}
	printf( "HashB                    : 0x%4x - ", descriptorData->HashB );
	    if(descriptorData->HashBValid == 1)
		{
		    printf( "valid\n" );
		}
		else
		{
		    printf( "not valid\n" );
		}
	printf( "-------------------------\n");
}

static void ext04_CheckNDisplayContents(int type, void* data)
{
	if (type == EXTENDED_DESCRIPTOR_04_TYPE)
	{
		ext04_DisplayContents(data);
	}
}
#endif

#ifdef __cplusplus 
}
#endif

#include "ntpackpop.h"

#endif /* __INCLUDED_EXTENDEDDESCRIPTOR04_H__ */
#endif //NT_LEGACY_4_25
