
#ifndef NT_LEGACY_4_25

#ifndef DEPRECATED_4_25
#warning: This file was part of a Xyratex specific framework and has been retired.
#warning: It is not and has never been required for Napatech Adapter operations.
#warning: Please remove this file from your project and recompile.
#warning: See file /include/xyratex_retired_readme.txt for more information.
#endif

#else //NT_LEGACY_4_25
#ifndef INCLUDED_FILTERSTRUCTURE_H_96715C6D_CCC6_4dc5_9561_17676A4543AF
#define INCLUDED_FILTERSTRUCTURE_H_96715C6D_CCC6_4dc5_9561_17676A4543AF

#include "basetype.h"

#include "ntpackpush.h"

#ifdef __cplusplus
extern "C" {
#endif

/* The following enum block relates to the structure ID groups */
enum
{
	eXSeriesPatternCompare,
	eXSeriesProtocolFunctionType1,
	eXSeriesErrorFunction,
	eXSeriesGroupType1,
	eXSeriesGroupType2,
	eXSeriesGroup,
	eXSeriesDynamicSliceFunction,
	eXSeriesFilterBlockOld,
	eXSeriesDynamicOffset,
	eXSeriesFrameSizeCompare,
	eXSeriesFrameIncludeGroupOnly,
	eXSeriesFrameExcludeGroupOnly,
	eXSeriesDefaultSlice,
	eXSeriesFrameInclude,
	eXSeriesFrameExclude,
	eXSeriesFrameIncludeErrorMask,
	eXSeriesFrameExcludeErrorMask,
	eXSeriesFilterBlock,
	eSSeriesFilterBlock,
	eXSeriesBytePatternCompare,
	/* Negated filters (match when condition specified does not occur in
	 * the frame) */
	eXSeriesNegatedPatternCompare,
	eXSeriesNegatedProtocolFunctionType1,
	eXSeriesNegatedErrorFunction,
	eXSeriesNegatedDynamicSliceFunction,
	eXSeriesNegatedBytePatternCompare,

    eXSeriesDynamicSliceLength,
	eXSeriesRetransmitInclude,
	eXSeriesRetransmitExclude,
	eXSeriesCAMInput,
	eXSeriesProtocolFunction,
	eXSeriesNegatedProtocolFunction,

	/* New definitions always go at end to maintain binary compatibility */
	
};

/* Sizes of various parts of the filtering unit. */
#define X_PATTERN_LENGTH                    16
#define X_PATTERN_MAX_OFFSET		    	255
#define X_PATTERN_COMPARE_COUNT   			64
#define X_PROTOCOL_FUNCTION_COUNT 			8
#define X_ERROR_FUNCTION_COUNT    			8
#define X_DYNAMIC_SLICE_COUNT     			16
#define X_TYPE1_GROUP_COUNT		  			32
#define X_TYPE2_GROUP_COUNT       			32
#define X_GROUP_COUNT						64
#define X_TYPE1_PATTERN_COMPARE_COUNT_SIZE  4
#define X_TYPE2_PATTERN_COMPARE_COUNT_SIZE  4
#define X_DYNAMIC_OFFSET_COUNT    			4
#define X_SIZE_COMPARE_COUNT      			2
#define X_NUM_CHANNELS            			4
#define X_CAM_INPUT_COUNT					2
#define X_CAM_STRING_LENGTH                 16
#define X_DEFAULT_SLICE_COUNT               1

typedef struct PatternCompare {
    bool_t InUse;
    uint32_t FixedOffset; /* word offset. (word = 4 bytes) */
    uint32_t PatternLength; /* length of pattern in words. (word = 4 bytes) */
    uint32_t Pattern[X_PATTERN_LENGTH];
    uint32_t PatternMask[X_PATTERN_LENGTH];
} XSeriesPatternCompare_t;

typedef struct PatternCompareByte
{
    bool_t InUse;
    uint32_t FixedOffset; /* byte offset */
    uint32_t PatternLength; /* length of pattern in bytes */
    uint8_t Pattern[X_PATTERN_LENGTH * sizeof(uint32_t)];
    uint8_t PatternMask[X_PATTERN_LENGTH * sizeof(uint32_t)];
} XSeriesBytePatternCompare_t;


enum MatchType {
    Match0 = 0,
    Match1 = 1,
    DontCare = 2,
};
    

enum Layer2Type {
    L2EtherII = 0,
    L2LLC     = 1,
    L2SNAP    = 2,
    L2Raw     = 3,
    L2Any     = 4
};

enum Layer3Type {
    L3IPv4  = 0,
    L3IPv6  = 1,
    L3IPX   = 2,
    L3Other = 3,
    L3Any   = 4,
};

enum Layer4Type {
    L4TCP   = 0,
    L4UDP   = 1,
    L4ICMP  = 2,
    L4Other = 3,
    L4Any   = 4
};


enum DynamicOffset {
    FrameStart          = 0x00,
    Layer2Frame         = 0x01,
    Layer2Header        = 0x02,
    Layer2Data          = 0x03,
	EthertypeLength		= 0x04,
	Ethertype			= 0x05,
    IPv4Frame           = 0x08,
    IPv4Header          = 0x09,
    IPv4Data            = 0x0a,
    IPv6Frame           = 0x10,
    IPv6Header          = 0x11,
    IPv6Data            = 0x12,
    IPXFrame            = 0x18,
    TCPFrame            = 0x20,
    TCPHeader           = 0x21,
    TCPData             = 0x22,
    UDPFrame            = 0x28,
    UDPHeader           = 0x29,
    UDPData             = 0x2a,
    ICMPFrame           = 0x30
};


typedef struct ProtocolFunctionType1 {
    bool_t InUse;
    uint8_t CiscoISL;
    uint8_t Vlan;
    uint8_t Jumbo;
    uint8_t Broadcast;
    uint8_t Layer2Type; /* enum actually 2bits */
    uint8_t Layer3Type; /* enum actually 2bits */
    uint8_t Layer4Type; /* enum actually 2bits */
} XSeriesProtocolFunctionType1_t;

typedef struct ProtocolFunction {
    bool_t InUse;
    uint8_t CiscoISL;
    uint8_t Vlan;
    uint8_t Jumbo;
    uint8_t Broadcast;
    uint8_t Layer2Type; /* enum actually 2bits */
    uint8_t Layer3Type; /* enum actually 2bits */
    uint8_t Layer4Type; /* enum actually 2bits */
    uint8_t Mpls;
} XSeriesProtocolFunction_t;

typedef struct ErrorFunction {
    bool_t InUse;
    uint8_t Small;
    uint8_t Large;
    uint8_t CVError;
    uint8_t CRCError;
    uint8_t IPChecksum;
    uint8_t TCPChecksum;
    uint8_t UDPChecksum;
} XSeriesErrorFunction_t;

/* Same as Type 1 but with pattern compares separated out */
typedef struct GroupType1 {
    bool_t InUse; 
    uint8_t PatternCompare[X_TYPE1_PATTERN_COMPARE_COUNT_SIZE];   /* 0-2 for each element */
    uint8_t ProtocolFunction ;   /* 0-2 */
    uint8_t ErrorFunction;       /* 0-2 */
    uint8_t CAMLookup0;          /* 0-2 */
    uint8_t CAMLookup1;          /* 0-2 */
    uint8_t SizeCompare0;        /* 0-2 */
    uint8_t SizeCompare1;        /* 0-2 */
} XSeriesGroupType1_t;

typedef struct GroupType2 {
    bool_t InUse;
    uint8_t PatternCompareX[X_TYPE2_PATTERN_COMPARE_COUNT_SIZE];     /* 0-2 for each element */
    uint8_t PatternCompareY[X_TYPE2_PATTERN_COMPARE_COUNT_SIZE];     /* 0-2 for each element */
} XSeriesGroupType2_t;

typedef struct Group {
    XSeriesGroupType1_t Group0_31[X_TYPE1_GROUP_COUNT];
    XSeriesGroupType2_t Group32_63[X_TYPE2_GROUP_COUNT];
} XSeriesGroup_t;

typedef struct DynamicSlice {
    bool_t InUse;
    uint8_t PatternCompare0;
    uint8_t PatternCompare16;
    uint8_t PatternCompare32;
    uint8_t PatternCompare48;
    uint8_t ProtocolFunction0;
    uint8_t ProtocolFunction1;
    uint8_t ErrorFunction;
    uint8_t CAMFunction0;
    uint8_t CAMFunction1;
    uint8_t ChannelNumber;
    uint16_t SliceLength;
} XSeriesDynamicSliceFunction_t;

typedef struct DynamicOffset_ {
    uint32_t DynamicOffset;
} XSeriesDynamicOffset_t;

typedef struct FrameSizeCompare_ {
    uint32_t FrameSize;
} XSeriesFrameSizeCompare_t;

typedef struct FrameIncludeGroupOnly_ {
    uint64_t IncludeMask;
} XSeriesFrameIncludeGroupOnly_t;

typedef struct FrameExcludeGroupOnly_ {
    uint64_t ExcludeMask;
} XSeriesFrameExcludeGroupOnly_t;

typedef struct DefaultSlice_ {
    uint32_t SliceLength;
} XSeriesDefaultSlice_t;

typedef struct FrameIncludeExclude_ {
    bool_t InUse;
	uint64_t GroupMask;
	uint8_t ErrorFunctionMask;
	uint8_t ProtocolFunctionMask;
	uint8_t SizeFunctionMask;
	uint8_t CAMFunctionMask;
} XSeriesFrameIncludeExclude_t;

typedef struct XSeriesFilterBlock_ {
    /* Filter control registers */
    uint32_t DynamicOffset[X_DYNAMIC_OFFSET_COUNT];
    uint32_t FrameSizeCompare[X_SIZE_COMPARE_COUNT];
    XSeriesFrameIncludeExclude_t FrameExclude[X_NUM_CHANNELS];
    XSeriesFrameIncludeExclude_t FrameInclude[X_NUM_CHANNELS];
    
    /* Pattern and function Filters */
    XSeriesPatternCompare_t PatternCompare[X_PATTERN_COMPARE_COUNT];
    XSeriesProtocolFunctionType1_t ProtocolFunction[X_PROTOCOL_FUNCTION_COUNT];
    XSeriesErrorFunction_t ErrorFunction[X_ERROR_FUNCTION_COUNT];
    uint32_t DefaultSlice;
    XSeriesDynamicSliceFunction_t DynamicSliceFunction[X_DYNAMIC_SLICE_COUNT - 1];
    XSeriesGroup_t GroupingFunction;
} XSeriesFilterBlock_t;

typedef struct XSeriesFilterBlockOld_ {
    /* Filter control registers */
    uint32_t DynamicOffset[X_DYNAMIC_OFFSET_COUNT];
    uint32_t FrameSizeCompare[X_SIZE_COMPARE_COUNT];
	/* Frame include exclude registers. In this structure variant only 
	 * groups can be included/excluded */
    uint64_t FrameExclude[X_NUM_CHANNELS];
    uint64_t FrameInclude[X_NUM_CHANNELS];
    
    /* Pattern and function Filters */
    XSeriesPatternCompare_t PatternCompare[X_PATTERN_COMPARE_COUNT];
    XSeriesProtocolFunctionType1_t ProtocolFunction[X_PROTOCOL_FUNCTION_COUNT];
    XSeriesErrorFunction_t ErrorFunction[X_ERROR_FUNCTION_COUNT];
    uint32_t DefaultSlice;
    XSeriesDynamicSliceFunction_t DynamicSliceFunction[X_DYNAMIC_SLICE_COUNT - 1];
    XSeriesGroup_t GroupingFunction;
} XSeriesFilterBlockOld_t;

#define STID_XSERIES_PATTERN_COMPARE MAKE_STRUCTURE_ID(eXSeriesPatternCompare, XSeriesPatternCompare_t )

#define STID_XSERIES_PROTOCOL_FUNCTION MAKE_STRUCTURE_ID(eXSeriesProtocolFunction, XSeriesProtocolFunction_t)
#define STID_XSERIES_PROTOCOL_FUNCTION_TYPE1 MAKE_STRUCTURE_ID(eXSeriesProtocolFunctionType1, XSeriesProtocolFunctionType1_t)

#define STID_XSERIES_ERROR_FUNCTION MAKE_STRUCTURE_ID(eXSeriesErrorFunction, XSeriesErrorFunction_t)

#define STID_XSERIES_GROUP_TYPE1 MAKE_STRUCTURE_ID(eXSeriesGroupType1, XSeriesGroupType1_t)

#define STID_XSERIES_GROUP_TYPE2 MAKE_STRUCTURE_ID(eXSeriesGroupType2, XSeriesGroupType2_t)

#define STID_XSERIES_GROUP MAKE_STRUCTURE_ID(eXSeriesGroup, XSeriesGroup_t)

#define STID_XSERIES_DYNAMIC_SLICE_FUNCTION MAKE_STRUCTURE_ID(eXSeriesDynamicSliceFunction, XSeriesDynamicSliceFunction_t)

#define STID_XSERIES_FILTER_BLOCK MAKE_STRUCTURE_ID(eXSeriesFilterBlock, XSeriesFilterBlock_t)

#define STID_XSERIES_FILTER_BLOCK_OLD MAKE_STRUCTURE_ID(eXSeriesFilterBlockOld, XSeriesFilterBlockOld_t)

#define STID_XSERIES_DYNAMIC_OFFSET MAKE_STRUCTURE_ID(eXSeriesDynamicOffset, XSeriesDynamicOffset_t)

#define STID_XSERIES_FRAME_SIZE_COMPARE MAKE_STRUCTURE_ID(eXSeriesFrameSizeCompare, XSeriesFrameSizeCompare_t)

/* These correspont to the include/exclude registers in v31 and earlier FPGAs */
#define STID_XSERIES_FRAME_INCLUDE_GROUP_ONLY MAKE_STRUCTURE_ID(eXSeriesFrameIncludeGroupOnly, XSeriesFrameIncludeGroupOnly_t)

#define STID_XSERIES_FRAME_EXCLUDE_GROUP_ONLY MAKE_STRUCTURE_ID(eXSeriesFrameExcludeGroupOnly, XSeriesFrameExcludeGroupOnly_t)

#define STID_XSERIES_FRAME_INCLUDE MAKE_STRUCTURE_ID(eXSeriesFrameInclude, XSeriesFrameIncludeExclude_t)

#define STID_XSERIES_FRAME_EXCLUDE MAKE_STRUCTURE_ID(eXSeriesFrameExclude, XSeriesFrameIncludeExclude_t)

#define STID_XSERIES_FRAME_INCLUDE_ERROR_ONLY MAKE_STRUCTURE_ID(eXSeriesFrameIncludeErrorMask, uint8_t)
#define STID_XSERIES_FRAME_EXCLUDE_ERROR_ONLY MAKE_STRUCTURE_ID(eXSeriesFrameExcludeErrorMask, uint8_t)

#define STID_XSERIES_DEFAULT_SLICE MAKE_STRUCTURE_ID(eXSeriesDefaultSlice, XSeriesDefaultSlice_t)

#define STID_XSERIES_BYTE_PATTERN_COMPARE MAKE_STRUCTURE_ID(eXSeriesBytePatternCompare, XSeriesBytePatternCompare_t )


#define STID_XSERIES_NEGATED_PATTERN_COMPARE MAKE_STRUCTURE_ID(eXSeriesNegatedPatternCompare, XSeriesPatternCompare_t )

#define STID_XSERIES_NEGATED_PROTOCOL_FUNCTION MAKE_STRUCTURE_ID(eXSeriesNegatedProtocolFunction, XSeriesProtocolFunction_t)
#define STID_XSERIES_NEGATED_PROTOCOL_FUNCTION_TYPE1 MAKE_STRUCTURE_ID(eXSeriesNegatedProtocolFunctionType1, XSeriesProtocolFunctionType1_t)

#define STID_XSERIES_NEGATED_ERROR_FUNCTION MAKE_STRUCTURE_ID(eXSeriesNegatedErrorFunction, XSeriesErrorFunction_t)

#define STID_XSERIES_NEGATED_DYNAMIC_SLICE_FUNCTION MAKE_STRUCTURE_ID(eXSeriesNegatedDynamicSliceFunction, XSeriesDynamicSliceFunction_t)

#define STID_XSERIES_NEGATED_BYTE_PATTERN_COMPARE MAKE_STRUCTURE_ID(eXSeriesNegatedBytePatternCompare, XSeriesBytePatternCompare_t )

#define STID_XSERIES_DYNAMIC_SLICE_LENGTH MAKE_STRUCTURE_ID(eXSeriesDynamicSliceLength, XSeriesDefaultSlice_t )

#define STID_XSERIES_RETRANSMIT_INCLUDE MAKE_STRUCTURE_ID(eXSeriesRetransmitInclude, XSeriesFrameIncludeExclude_t)

#define STID_XSERIES_RETRANSMIT_EXCLUDE MAKE_STRUCTURE_ID(eXSeriesRetransmitExclude, XSeriesFrameIncludeExclude_t)

#define STID_XSERIES_CAM_INPUT MAKE_STRUCTURE_ID(eXSeriesCAMInput, uint32_t)


#ifdef __cplusplus
}
#endif

#include "ntpackpop.h"


#endif /* INCLUDED_FILTERSTRUCTURE_H */

#endif //NT_LEGACY_4_25

