// $Id: devicecontrolinterface.h 14870 2011-10-13 07:23:23Z bk $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * This file contains the common types that can be used by any interface.
 */

#ifndef __DEVICECONTROLINTERFACE_H__
#define __DEVICECONTROLINTERFACE_H__

#include "ostype.h"
#include "basetype.h"

#ifdef _NT_DRIVER
#define DEVICE_CONTROL_INTERFACE_VERSION        4
#else
#define DEVICE_CONTROL_INTERFACE_VERSION        1
#endif

typedef struct deviceControlInterface_v3
{
	uint16_t size;
	uint16_t version;
	void *context;
	NT_STATUS (*DeviceControl)(void *context,
                              StructureID structId,
                              void *pDeviceControl);  
} DEVICE_CONTROL_INTERFACE_V3;

typedef struct deviceControlInterface_v4
{
	uint16_t size;
	uint16_t version;
	void *context;
  
	NT_STATUS (*DeviceControl)(void *context,
                              StructureID structId,
                              void *pDeviceControl);
  
	NT_STATUS (*ImageUpload)(void *context,
                            StructureID structId,
                            void *pDeviceControl);  
  
} DEVICE_CONTROL_INTERFACE_V4;

typedef struct deviceControlInterface
{
	uint16_t size;
	uint16_t version;
	void *context;
	NT_STATUS (*ProgramDevice)(void *context, 
								int deviceId,
								uint32_t offset,
								const void *data,
								uint32_t dataLength,
								uint32_t deviceFlags);
} DEVICE_CONTROL_INTERFACE;

#endif // __DEVICECONTROLINTERFACE_H__
