// $Id: hardwaremonitorinterface.h 14870 2011-10-13 07:23:23Z bk $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * This file contains the common types that can be used by any interface.
 */

#ifndef __HARDWAREMONITORINTERFACE_H__
#define __HARDWAREMONITORINTERFACE_H__

#include "ostype.h"
#include "basetype.h"

#define HARDWARE_MONITOR_INTERFACE_VERSION        1

typedef struct hardwareMonitorInterface
{
  uint16_t size;
  uint16_t version;
  void * context;
  NT_STATUS (*GetSensorBlockSize)(void *context, 
                                   uint32_t *blockSize);
  NT_STATUS (*GetPartSensorBlockSize)(void *context, 
                                       uint32_t structid,
                                       uint32_t *blockSize);
  NT_STATUS (*GetSensors)(void *context,
                           uint32_t structid,
                           void *sensorBlock,
                           uint32_t blockSize);
  NT_STATUS (*GetPartSensors)(void *context,
                               uint32_t structid,
                               void *sensorBlock,
                               uint32_t blockSize);
	NT_STATUS (*SetSensors)(void *context,
                           uint32_t structid,
                           const void *sensorBlock,
                           uint32_t blockSize);

} HARDWARE_MONITOR_INTERFACE;

#endif // __HARDWAREMONITORINTERFACE_H__
