// $Id: identifiers.h 14931 2011-10-17 08:21:14Z ph $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 */

#ifndef __IDENTIFIERS_H__
#define __IDENTIFIERS_H__

#define ASYNC_EVENT_CONTROL_INTERFACE_ID     0x00010000
#define GET_ASYNC_EVENT_INTERFACE_ID         0x00010001
#define DIAGNOSTIC_INTERFACE_ID              0x00020000
#define PACKET_FEED_INTERFACE_ID             0x00030000
#define BASIC_TRAFFIC_GEN_INTERFACE_ID       0x00040000
#define STATISTICS_INTERFACE_ID              0x00050000
#define VITAL_PRODUCT_DATA_INTERFACE_ID      0x00060000
#define LOWLEVEL_FILTER_INTERFACE_ID         0x00070000
#define REGISTER_ACCESS_INTERFACE_ID         0x00080000
#define DEVICE_CONTROL_INTERFACE_ID          0x00090000
#define MEMORY_ACCESS_INTERFACE_ID           0x000a0000
#define PROM_INTERFACE_ID                    0x000b0000
#define HARDWARE_MONITOR_INTERFACE_ID        0x000c0000
#define CARD_CONFIGURATION_INTERFACE_ID      0x000d0000
#define CARD_STATUS_INTERFACE_ID             0x000e0000
#define CAPABILITIES_INTERFACE_ID            0x000f0000
#define PACKET_CLASSIFICATION_INTERFACE_ID   0x00100000
#define ASYNC_EVENT_SINK_ID					         0x10010000
#define CARD_INFO_INTERFACE_ID               0x10020000

#define VPD_ACCESS_INTERFACE_ID VITAL_PRODUCT_DATA_INTERFACE_ID

/*
 * New interface variants used to pack inside the 64 bit wide StructureID
 */  
#define ASYNC_EVENT_CONTROL_IF_ID     0x01
#define GET_ASYNC_EVENT_IF_ID         0x02
#define DIAGNOSTIC_IF_ID              0x03
#define PACKET_FEED_IF_ID             0x04
#define BASIC_TRAFFIC_GEN_IF_ID       0x05
#define STATISTICS_IF_ID              0x06
#define VITAL_PRODUCT_DATA_IF_ID      0x07
#define LOWLEVEL_FILTER_IF_ID         0x08
#define REGISTER_ACCESS_IF_ID         0x09
#define DEVICE_CONTROL_IF_ID          0x0A
#define MEMORY_ACCESS_IF_ID           0x0B
#define PROM_IF_ID                    0x0C
#define HARDWARE_MONITOR_IF_ID        0x0D
#define CARD_CONFIGURATION_IF_ID      0x0E
#define CARD_STATUS_IF_ID             0x0F
#define CAPABILITIES_IF_ID            0x10
#define PACKET_CLASSIFICATION_IF_ID   0x11
#define ASYNC_EVENT_SINK_IF_ID        0x12
#define CARD_INFO_IF_ID               0x13

#define VPD_ACCESS_IF_ID VITAL_PRODUCT_DATA_IF_ID

  
#define AEC_ENABLE_DEBUG_EVENT 0
#define AEC_ENABLE_ASYNC_EVENT 1
#define AEC_SET_DEBUG_LEVEL    2

#define GAE_GET_ASYNC_EVENT        0
#define GAE_CANCEL_GET_ASYNC_EVENT 1
#define GAE_RESET_GET_ASYNC_EVENT  2

#define DIAG_DIAGNOSTIC_DUMP 0

#define PF_SETUP_PACKET_FEED_ENGINE         0
#define PF_CREATE_PACKET_FEED               1
#define PF_DESTROY_PACKET_FEED              2
#define PF_START_PACKET_FEED                3
#define PF_GET_PACKET_FEED_BUFFERS          4
#define PF_STOP_PACKET_FEED                 5
#define PF_GET_NEXT_FEED_BUFFER             6
#define PF_RELEASE_FEED_BUFFER              7
#define PF_GET_PACKET_FEED_COUNTERS         8
#define PF_GET_PACKET_FEED_COUNT            9
#define PF_GET_PACKET_FEED_DESCRIPTION     10
#define PF_GET_PACKET_FEED_STATUS          11
#define PF_SET_PACKET_FEED_CHANNEL_CONTROL 12
#define PF_GET_PACKET_FEED_CHANNEL_CONTROL 13
#define PF_RELEASE_TX_BUFFER               14
#define PF_SEND_TX_BUFFER                  15
#define PF_FLUSH_TX_PORTS                  16

#define BTG_SEND_PACKET 0

#define STAT_GET_SINGLE     0
#define STAT_GET_INDIVIDUAL 1
#define STAT_RESET_STATISTICS 2
#define STAT_SET_OPTIONS 3

#define VPD_READ_VITAL_PRODUCT_DATA 0
#define VPD_WRITE_VITAL_PRODUCT_DATA 1

#define LLFILTER_SET_FILTER_DEFINITIONS     0
#define LLFILTER_SET_INDIVIDUAL_FILTER      1
#define LLFILTER_COMBINE_INDIVIDUAL_FILTERS 2
#define LLFILTER_CLEAR_INDIVIDUAL_FILTER    3

#define RA_REGISTER_READ8    0
#define RA_REGISTER_READ16   1
#define RA_REGISTER_READ32   2
#define RA_REGISTER_READ64   3
#define RA_REGISTER_WRITE8   4
#define RA_REGISTER_WRITE16  5
#define RA_REGISTER_WRITE32  6
#define RA_REGISTER_WRITE64  7
#define RA_GET_REGISTER_BLOCK_INFORMATION 8

#define MA_READ_MEMORY            0
#define MA_WRITE_MEMORY           1
#define MA_GET_MEMORY_BUFFER_INFO 2
#define MA_MEMORY                 3

#define DC_PROGRAM_DEVICE    0
#define DC_DEVICE_CONTROL    1

#define PROM_READ_PROM       0
#define PROM_WRITE_PROM      1
#define PROM_READ_EEPROM     2
#define PROM_WRITE_EEPROM    3

#define HM_GET_SENSORS                0
#define HM_SET_SENSORS                1
#define HM_GET_SENSOR_BLOCK_SIZE      2
#define HM_GET_PART_SENSORS           3
#define HM_GET_PART_SENSOR_BLOCK_SIZE 4

#define CC_GET_PORTBYPASS_MODE            0
#define CC_SET_PORTBYPASS_MODE            1
#define CC_READ_NIM_DATA                  2
#define CC_WRITE_NIM_DATA                 3
#define CC_SET_AUTO_NEGOTIATION_MODE      4
#define CC_GET_AUTO_NEGOTIATION_MODE      5
#define CC_SET_CARD_CONFIGURATION_DETAILS 6
#define CC_GET_CARD_CONFIGURATION_DETAILS 7
#define CC_SET_TTIMESTAMP_CONFIGURATION   8
#define CC_GET_TTIMESTAMP_CONFIGURATION   9
#define CC_ADAPTER_PAIR_CONFIGURATION    10
#define CC_FAILOVER_HEARTBEAT_SIGNAL     11

#define CS_GET_CHANNEL_STATUS       0
#define CS_GET_CHANNELS_LINK_STATUS 1

#define CAP_GET_CAPABILITIES 0

#define PC_CREATE_EXPRESSION            0
#define PC_COMBINE_EXPRESSION           1
#define PC_DESTROY_EXPRESSION           2
#define PC_CREATE_FUNCTION              3
#define PC_COMBINE_FUNCTION             4
#define PC_DESTROY_FUNCTION             5
#define PC_ASSIGN_FUNCTION_RESOURCES    6
#define PC_RELEASE_FUNCTION_RESOURCES   7
#define PC_ENABLE_FUNCTION              8
#define PC_DISABLE_FUNCTION             9
#define PC_ADD_SIGNATURE_MATCH_ENTRY    10
#define PC_REMOVE_SIGNATURE_MATCH_ENTRY 11
#define PC_DESTROY_ALL_CLASSIFICATION   12
#define PC_PACKET_CLASSIFICATION        13

#define CI_GET_VERSION                  0
#define CI_GET_DEVICE_NAME              1
#define CI_GET_CONNECTION_NAME          2
#define CI_GET_CONNECTION_GUID          3
#define CI_GET_SERVICE_NAME             4
#define CI_GET_PCISLOTBUS_DEVICE        5
#define CI_GET_CARD_INFO                6

#endif // __IDENTIFIERS_H__
