// $Id: memoryaccessinterface.h 14870 2011-10-13 07:23:23Z bk $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * Memory testing API to allow for DMA transfers on a new card to be tested
 */

#ifndef __MEMORYACCESSINTERFACE_H__
#define __MEMORYACCESSINTERFACE_H__

#include "ostype.h"
#include "basetype.h"

#ifdef _NT_DRIVER
#define MEMORY_ACCESS_INTERFACE_VERSION        2
#else
#define MEMORY_ACCESS_INTERFACE_VERSION        1
#endif

typedef struct memoryAccessInterface
{
	uint16_t size;
	uint16_t version;
	void *context;
	NT_STATUS (*ReadMemory)(void *device, int region,
							 uint32_t offset, void *buffer,
							 uint32_t bufferSize, uint32_t *bytesRead);
	NT_STATUS (*WriteMemory)(void *device, int region,
							  uint32_t offset, const void *buffer,
							  uint32_t bufferSize, uint32_t *bytesWritten);

  NT_STATUS (*GetMemoryBufferInfo)(void *device,
                                    uint64_t *physicalAddress,
                                    uint32_t *length);
} MEMORY_ACCESS_INTERFACE;

typedef struct memoryAccessInterfaceV2
{
	uint16_t size;
	uint16_t version;
	void *context;
  NT_STATUS (*Memory)(void *context,
                       StructureID structid,
                       void *data);
} MEMORY_ACCESS_INTERFACE_V2;

#endif // __MEMORYACCESSINTERFACE_H__
