// $Id: workliststructure.h 16051 2011-11-30 12:20:27Z ps $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * Worklist interface structure definitions
 */

#ifndef __NTAPI_WORKLISTSTRUCTURE_H__
#define __NTAPI_WORKLISTSTRUCTURE_H__

#define _MAX_FEEDS_PER_WORKLIST_          5
#define _MAX_DESCRIPTORS_PER_WORKLIST_    10000

typedef uint32_t WorklistHandle_t;

typedef struct {
  handle_t   hCard;                               /* Handle to open card */
  FeedHandle hFeed;                               /* Handle to running feed */
} FeedInfo_t;

typedef struct {
  uint32_t   numFeeds;                            /* Number of feeds in this worklist */
  FeedInfo_t aFeedInfo[_MAX_FEEDS_PER_WORKLIST_]; /* Information about each feed in this worklist*/
} WorklistConfigType1_t;

#define STID_WORKLIST_CONFIG_TYPE1 \
    MAKE_STRUCTURE_ID(eWorklistConfigType1, WorklistConfigType1_t)

typedef struct {
  uint32_t maxDescr;                              /* Maximum number of packet descriptors to get */
} WorklistBufferRequestType1_t;

#define STID_WORKLIST_BUFFER_REQUEST_TYPE1 \
    MAKE_STRUCTURE_ID(eWorklistBufferRequestType1, WorklistBufferRequestType1_t)

typedef struct {
  uint32_t numDescr;                                                               /* Number of packet descriptors in array */
  uint8_t  aAdapterNumber[_MAX_DESCRIPTORS_PER_WORKLIST_];                         /* The adapter this descriptor was received on */
  PacketDescriptorNtSeriesType1_t *apDescriptors[_MAX_DESCRIPTORS_PER_WORKLIST_];  /* Packet descriptor pointers */
} WorklistBufferInformationType1_t;

#define STID_WORKLIST_BUFFER_INFORMATION_TYPE1 \
    MAKE_STRUCTURE_ID(eWorklistBufferInformationType1, WorklistBufferInformationType1_t)

#endif // __NTAPI_WORKLISTSTRUCTURE_H__
