#ifndef NT_LEGACY_4_25

#ifndef DEPRECATED_4_25
#warning: This file was part of a Xyratex specific framework and has been retired.
#warning: It is not and has never been required for Napatech Adapter operations.
#warning: Please remove this file from your project and recompile.
#warning: See file /include/xyratex_retired_readme.txt for more information.
#endif

#else //NT_LEGACY_4_25
#ifndef INCLUDED_HARDWAREFILTERSTRUCTURE_H
#define INCLUDED_HARDWAREFILTERSTRUCTURE_H

#include <basetype.h>
#include <oswrapper.h>

#include "ntpackpush.h"

#include "filterstructure.h"

#ifdef __cplusplus 
extern "C" {
#endif


enum {
    ePClassXSeriesProtocolPattern,
    ePClassXSeriesCombinedProtocol,
    ePClassXSeriesGeneralPattern,
    ePClassXSeriesCombinedError,
    ePClassXSeriesSize,
    ePClassXSeriesIncludeExclude,
    ePClassXSeriesSlice,
    ePClassXSeriesSignature
};

typedef struct PClassXSeriesGeneralPattern
{
    XSeriesBytePatternCompare_t Compare;
    XSeriesDynamicOffset_t Offset;
} PClassXSeriesGeneralPattern_t;

#define STID_PCLASS_XSERIES_GENERAL_PATTERN \
	MAKE_STRUCTURE_ID(ePClassXSeriesGeneralPattern, \
			  PClassXSeriesGeneralPattern_t)

#define MAX_COMBINED_PROTOCOL 2
typedef struct PClassXSeriesCombinedProtocol
{
    uint32_t numberProtocols;
    XSeriesProtocolFunction_t Protocol[MAX_COMBINED_PROTOCOL];
} PClassXSeriesCombinedProtocol_t;

#define STID_PCLASS_XSERIES_COMBINED_PROTOCOL \
	MAKE_STRUCTURE_ID(ePClassXSeriesCombinedProtocol, \
			  PClassXSeriesCombinedProtocol_t)


#define MAX_PROTOCOL_PATTERNS 2
typedef struct PClassXSeriesProtocolPattern
{
    uint32_t numberCompares;
    PClassXSeriesGeneralPattern_t GeneralPattern[MAX_PROTOCOL_PATTERNS];
    PClassXSeriesCombinedProtocol_t CombinedProtocol;
} PClassXSeriesProtocolPattern_t;

#define STID_PCLASS_XSERIES_PROTOCOL_PATTERN \
	MAKE_STRUCTURE_ID(ePClassXSeriesProtocolPattern, \
			  PClassXSeriesProtocolPattern_t)

#define MAX_COMBINED_ERRORS 8
typedef struct PClassXSeriesCombinedError
{
    uint32_t numberErrors;
    XSeriesErrorFunction_t Error[MAX_COMBINED_ERRORS];
} PClassXSeriesCombinedError_t;

#define STID_PCLASS_XSERIES_COMBINED_ERROR \
	MAKE_STRUCTURE_ID(ePClassXSeriesCombinedError, \
			  PClassXSeriesCombinedError_t)


typedef struct PClassXSeriesGeneralSize
{
    XSeriesFrameSizeCompare_t Size;
    bool_t negated;
} PClassXSeriesGeneralSize_t;

#define MAX_SIZE_COMPARES 2
typedef struct PClassXSeriesSize
{
    uint32_t numberCompares;
    PClassXSeriesGeneralSize_t GeneralSize[MAX_SIZE_COMPARES];
} PClassXSeriesSize_t;

#define STID_PCLASS_XSERIES_SIZE \
	MAKE_STRUCTURE_ID(ePClassXSeriesSize, \
			  PClassXSeriesSize_t)


typedef struct PClassXSeriesSignature
{
    uint32_t signatureId;
} PClassXSeriesSignature_t;

#define STID_PCLASS_XSERIES_SIGNATURE \
	MAKE_STRUCTURE_ID(ePClassXSeriesSignature, \
			  PClassXSeriesSignature_t)


enum 
{
    PClass_ActionInclude,
    PClass_ActionExclude,
    PClass_ActionRetransmitInclude,
    PClass_ActionRetransmitExclude,
    PClass_ActionTag
};

typedef struct PClassXSeriesIncludeExclude
{
    uint32_t Channels;
    uint8_t Type;
} PClassXSeriesIncludeExclude_t;

#define STID_PCLASS_XSERIES_INCLUDE_EXCLUDE \
	MAKE_STRUCTURE_ID(ePClassXSeriesIncludeExclude, \
			  PClassXSeriesIncludeExclude_t)
    

typedef struct PClassXSeriesSlice
{
    uint32_t Channels;
    XSeriesDefaultSlice_t slice;
    uint16_t priority;
} PClassXSeriesSlice_t;

#define STID_PCLASS_XSERIES_SLICE \
	MAKE_STRUCTURE_ID(ePClassXSeriesSlice, \
			  PClassXSeriesSlice_t)
    

#ifdef __cplusplus 
}
#endif

#include "ntpackpop.h"

#endif /* INCLUDED_HARDWAREFILTERSTRUCTURE_H */
#endif //NT_LEGACY_4_25
