#ifndef _INCLUDE_PCAP_NAPATECH_INTL_H
#define _INCLUDE_PCAP_NAPATECH_INTL_H

#include "pcap-napatech-version.h"

/* To send detailed debug messages to a log file */
//#define NAPATECH_DEBUG
/* To get call trace to a log file */
//#define NAPATECH_CALL_TRACE

#define MAX_DEV_NAME_SIZE      128
#define MAX_SUPPORTED_CARDS    4

// The TX segments must timeout after this amount of usec
#define TX_SEGMENT_TIMEOUT_MICROSEC 10000

// Per default the TX part of this libpcap implementation
// expect that the caller if handling delays between packets
// so we calculate the time between function calls and get the
// inter-packet gab from that.
// Comment out the define below to get packets sent using the
// txNow feature (asap).
#define USE_FUNCTION_CALL_IPG

// Default the NT adapters deliver packets with CRC. Enabling the define
// below will ensure that the wireLength is without CRC.
//#define CAPTURE_WITHOUT_CRC

#define NAPATECH3G_NTPCAP_INI_FILE_PATH  "/opt/napatech3/config/ntpcap.ini"
#define NAPATECH3G_MAX_STREAMS 256
#define MAX_FILTERS_PER_INI_SEC 256

#endif /* _INCLUDE_PCAP_NAPATECH_INTL_H */
