// $Id: Capabilities.c 14206 2011-09-08 16:47:22Z ps $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * This tool dumps the adapter capabilities.
 */

#ifdef WIN32
#include <Windows.h>
#else
#include <ctype.h>
#include <string.h>
#include <stdarg.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <time.h>
#endif
#include <toolslib.h>

static CommandLineOptions_t tools_options[] = {
  {NULL, NULL, NULL, 0, NULL}};

static char tool_description[] = {"Display Adapter capabilities.\n"};
static char output_description[] = {"\n"};

int main(int argc, char *argv[])
{
  uint32_t  cardIndex;

  /* Parse the command line and initialize the needed variables. */    
  if(InitApplication(&argc, argv, FALSE /* any card. */, &cardIndex,
                     tools_options, tool_description,
                     output_description) == -1) {
    exit(-1);
  }

  DisplayProgramHeader(argv[0], PRG_TOOL);

  GetCapabilities((uint8_t)cardIndex);

  /* shutdown card */
  CardShutdown(0);

  DisplayProgramFooter();
  
  return 0;
}

