// $Id: NTCI_hardwaremonitor.h 16051 2011-11-30 12:20:27Z ps $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * C functions to access the driver interface Hardware Monitor.
 */

#ifndef __NTCI_HARDWAREMONITOR_H__
#define __NTCI_HARDWAREMONITOR_H__

#include "NTCommonInterface.h"

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_GetSensorsBlockSize( IN  handle_t    hCard,
                                                    OUT uint32_t *  blockSize);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_GetPartSensorsBlockSize( IN  handle_t    hCard,
                                                    IN  StructureID structid,
                                                    OUT uint32_t *  blockSize);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_GetSensors(  IN  handle_t    hCard,
                                            IN  StructureID structid,
                                            OUT void *      sensorBlock,
                                            IN  uint32_t    blockSize);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_GetPartSensors(  IN  handle_t    hCard,
                                            IN  StructureID structid,
                                            OUT void *      sensorBlock,
                                            IN  uint32_t    blockSize);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_SetSensors(  IN  handle_t    hCard,
                                            IN  StructureID structid,
                                            IN  void *      sensorBlock,
                                            IN  uint32_t    blockSize);

#endif // __NTCI_HARDWAREMONITOR_H__
