// $Id: NTCI_packetclassification.h 16051 2011-11-30 12:20:27Z ps $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * C functions to access the driver interface Packet Classification.
 */

#ifndef __NTCI_PACKETCLASSIFICATION_H__
#define __NTCI_PACKETCLASSIFICATION_H__

#include "NTCommonInterface.h"

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_CreateExpression(            IN  handle_t    hCard,
                                                                    OUT uint32_t *  expressionId,
                                                                    IN  StructureID componentType,
                                                                    IN  void *      component,
                                                                    IN  uint8_t     unaryFunction);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_CombineExpression(           IN  handle_t    hCard,
                                                                    IN  uint32_t    expressionId,
                                                                    IN  StructureID componentType,
                                                                    IN  void *      component,
                                                                    IN  uint8_t     unaryFunction,
                                                                    IN  uint8_t     binaryFunction);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_DestroyExpression(           IN  handle_t    hCard,
                                                                    IN  uint32_t    expressionId);


NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_CreateFunction(              IN  handle_t    hCard,
                                                                    OUT uint32_t *  functionId,
                                                                    IN  uint32_t    expressionId,
                                                                    IN  StructureID actionType,
                                                                    IN  void *      action);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_CombineFunction(             IN  handle_t    hCard,
                                                                    IN  uint32_t    functionId,
                                                                    IN  StructureID actionType,
                                                                    IN  void *      action);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_DestroyFunction(             IN  handle_t    hCard,
                                                                    IN  uint32_t    functionId);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_AssignFunctionResources(     IN  handle_t    hCard,
                                                                    IN  uint32_t    functionId,
                                                                    OUT uint32_t *  classificationTag);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_ReleaseFunctionResources(    IN  handle_t    hCard,
                                                                    IN  uint32_t    functionId);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_EnableFunction(              IN  handle_t    hCard,
                                                                    IN  uint32_t    functionId,
                                                                    IN  bool_t      lastOperation);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_DisableFunction(             IN  handle_t    hCard,
                                                                    IN  uint32_t    functionId,
                                                                    IN  bool_t      lastOperation);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_AddSignatureMatchEntry(      IN  handle_t    hCard,
                                                                    IN  StructureID entryType,
                                                                    IN  void *      entry,
                                                                    IN  StructureID entryActionType,
                                                                    IN  void *      entryAction,
                                                                    OUT uint32_t *  entryIdentifier,
                                                                    IN  bool_t      writeNow);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_RemoveSignatureMatchEntry(   IN  handle_t    hCard,
                                                                    IN  uint32_t    entryIdentifier,
                                                                    IN  bool_t      writeNow);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_DestroyAllClassificationEntries(   IN  handle_t    hCard);


NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_PacketClassification(        IN  handle_t    hCard,
                                                                    IN  StructureID structId,
                                                                    IN  void *      classificationData);

#endif // __NTCI_PACKETCLASSIFICATION_H__
