// $Id: NTCI_packetfeed.h 16051 2011-11-30 12:20:27Z ps $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * C functions to access the driver interface Packet Feed.
 */

#ifndef __NTCI_PACKETFEED_H__
#define __NTCI_PACKETFEED_H__

#include "NTCommonInterface.h"
#include "packetfeedstructure.h"

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_SetupPacketFeedEngine(   IN  handle_t    hCard,
                                                                IN  uint32_t    numFeeds,
                                                               NOUSE IN  uint32_t *  Reserved0);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_CreatePacketFeed(IN  handle_t    hCard,
                                                        IN  uint32_t    feedIndex,
                                                        IN  uint32_t    channelsBitmask,
                                                        IN  uint32_t    Reserved0,
                                                        IN  uint32_t    Reserved1,
                                                        IN  StructureID idFeedConfig,
                                                        IN  void *      feedConfig,
                                                        OUT FeedHandle * pfeedHandle);

NTCOMMONLIB uint32_t NTCOMMONCALL  NTCI_DestroyPacketFeed(  IN  handle_t   hCard,
                                                            IN  FeedHandle feed );

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_StartPacketFeed( IN  handle_t   hCard,
                                                        IN  FeedHandle feed );

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_StopPacketFeed(  IN  handle_t   hCard,
                                                        IN  FeedHandle feed );

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_GetPacketFeedBuffers(IN  handle_t    hCard,
                                                            IN  FeedHandle  feed,
                                                            IN  StructureID idFeedBufferInformation,
                                                            OUT void *      feedBufferInformation);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_GetPacketFeedCount(  IN  handle_t    hCard,
                                                            OUT uint32_t *  numFeeds );

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_GetPacketFeedDescription(IN  handle_t    hCard,
                                                                IN  uint32_t    feedIndex,
                                                                IN  StructureID idFeedDescription,
                                                                OUT void *      feedDescription );

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_GetPacketFeedStatus( IN  handle_t    hCard,
                                                            IN  FeedHandle  feed,
                                                            IN  StructureID idFeedStatus,
                                                            OUT void *      feedStatus);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_GetNextBuffer(   IN  handle_t    hCard,
                                                        IN  FeedHandle  feed,
                                                        IN  StructureID idBufferRequest,
                                                        IN  void *      bufferRequest,
                                                        IN  StructureID idBufferInformation,
                                                        OUT void*       bufferInformation);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_ReleaseBuffer(   IN  handle_t    hCard,
                                                        IN  FeedHandle  feed,
                                                        IN  StructureID idBufferInformation,
                                                        IN  void *      bufferInformation );


NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_SetPacketFeedChannelControl( IN handle_t    hCard,
                                                                    IN FeedHandle  feed,
                                                                    IN uint32_t    channelsBitmask,
                                                                    IN StructureID portControlId,
                                                                    IN void *      portControlInformation);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_GetPacketFeedChannelControl( IN  handle_t    hCard,
                                                                    IN  FeedHandle  feed,
                                                                    IN  uint32_t    channelBitmask,
                                                                    IN  StructureID portControlId,
                                                                    OUT void *      portControlInformation);

NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_SendPacket( IN  handle_t hCard,
                                                   IN int      channel,
                                                   IN void *   packetData,
                                                   IN uint32_t packetDataLength);

// Flush all on or more tx queues
NTCOMMONLIB uint32_t NTCOMMONCALL NTCI_FlushTxPorts( IN  handle_t hCard,
                                                     IN  uint32_t ChannelBitmask,
                                                     IN  bool_t enable);

#endif // __NTCI_PACKETFEED_H__
