// $Id: commontypes.h 17384 2012-02-16 14:48:40Z ps $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * This file contains the common types that can be used by any interface.
 */

#ifndef __NTAPI_COMMONTYPES_H__
#define __NTAPI_COMMONTYPES_H__

#include "basetype.h"

/* Timestamp type */
typedef enum
{
  TIMESTAMP_NATIVE,       /* 64bit 10ns resolution timer from a base of 0 */
  TIMESTAMP_NDIS,         /* 64bit 100ns resolution timer from a base of January 1, 1601 */
  TIMESTAMP_PCAP,         /* 32bits seconds and 32bits usecs from a base of January 1, 1970 */
  TIMESTAMP_NATIVE_NDIS,  /* 64bit 10ns resolution timer from a base of January 1, 1601 */
  TIMESTAMP_NATIVE_UNIX,  /* 64bit 10ns resolution timer from a base of January 1, 1970 */
  TIMESTAMP_PCAP_NANOTIME,/* 32bits seconds and 32bits nsecs from a base of January 1, 1970 */
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */ #ifdef NT_LEGACY_4_25
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */   TIMESTAMP_XYRATEX_RESERVED_TYPE1 = 100
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */ #endif //NT_LEGACY_4_25
} TimestampType_t;

/* Capabilities Identifier type */
typedef uint32_t CapabilitiesId_t;

#endif // __NTAPI_COMMONTYPES_H__
