// $Id: devicecontrolstructure.h 16051 2011-11-30 12:20:27Z ps $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * Structure Definitions that are used by the external interface
 */

#ifndef __NTAPI_DEVICECONTROLSTRUCTURE_H__
#define __NTAPI_DEVICECONTROLSTRUCTURE_H__

#include "basetype.h"
#include "ntpackpush.h"

#define LOADED_BY_LENGTH 32
#define IMAGE_FILE_NAME_LENGTH  64

enum
{
  eProgramDeviceType1,
  eChangeBootImageType1,
  eFpgaImageBootStatusType1,
};

typedef struct {
  uint32_t   deviceImageSize;
  uint32_t   programFlags;
  char       achImageFileName[IMAGE_FILE_NAME_LENGTH];
  char       achLoadedBy[LOADED_BY_LENGTH];
  uint8_t   *pDeviceImage;
} ProgramDeviceType1_t;

#define STID_PROGRAM_DEVICE_TYPE1 \
    MAKE_STRUCTURE_ID(eProgramDeviceType1, ProgramDeviceType1_t)

typedef struct {
  uint32_t   bootImageNumber;
} ChangeBootImageType1_t;

#define STID_CHANGE_BOOT_IMAGE_TYPE1 \
    MAKE_STRUCTURE_ID(eChangeBootImageType1, ChangeBootImageType1_t)

typedef struct {
  uint8_t primaryImageChanged;
  uint8_t primaryImageNumber;
  uint8_t imageState;
} FpgaImageBootStatusType1_t;

#define STID_FPGA_IMAGE_BOOT_STATUS_TYPE1 \
    MAKE_STRUCTURE_ID(eFpgaImageBootStatusType1, FpgaImageBootStatusType1_t)

#include "ntpackpop.h"

#endif // __NTAPI_DEVICECONTROLSTRUCTURE_H__
