// $Id: fpgainfostructure.h 17384 2012-02-16 14:48:40Z ps $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * Query FPGA image status
 */

#ifndef __NTAPI_FPGAINFOSTRUCTURE_H__
#define __NTAPI_FPGAINFOSTRUCTURE_H__

#include "basetype.h"
#include "ntpackpush.h"

enum
{
  eFPGAInfoBlockType1 = 100,  //obsoleted. Use type2
  eFPGAInfoBlockType2,        //obsoleted. Use type2
  eFPGAInfoBlockType3,        //obsoleted. Use type2
  eXfmFileHeaderType1,        //obsoleted. Use type2
  eFpgaImageHeaderType1,      //obsoleted. Use type2
  eFpgaImageHeaderType2,
  eFpgaImageStatusType,
};

/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */ #ifdef NT_LEGACY_4_25
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */ enum {
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */   XFM_FILE_PLAIN_TEXT_HEADER_BYTE_LENGTH = 64,
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */   NUM_BYTES_PER_32BIT_WORD = 4,
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */ 	XFM_FILE_FILENAME_BYTE_LENGTH = 64,
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */ 	XFM_FILE_DATE_TIME_BYTE_LENGTH = 8,
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */ 	XFM_FILE_ADDIT_COMMENT_BYTE_LENGTH = 1024,
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */ 	NUMBER_OF_FPGA_ATTRIBUTES = 16,
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */   XFM_FILE_HEADER_STRUCT_ID_FILE_BYTE_POS = XFM_FILE_PLAIN_TEXT_HEADER_BYTE_LENGTH,
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */   XFM_FILE_HEADER_STRUCT_ID_IMAGE_BYTE_POS = (XFM_FILE_HEADER_STRUCT_ID_FILE_BYTE_POS + NUM_BYTES_PER_32BIT_WORD),
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */ };
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */ typedef struct{
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */     uint8_t     FileComment[XFM_FILE_PLAIN_TEXT_HEADER_BYTE_LENGTH] DEPRECATED_4_25;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */     uint8_t     StructureId[NUM_BYTES_PER_32BIT_WORD] DEPRECATED_4_25;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */     uint8_t     ImageHeaderStructureId[NUM_BYTES_PER_32BIT_WORD] DEPRECATED_4_25;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */     uint8_t     Filename[XFM_FILE_FILENAME_BYTE_LENGTH] DEPRECATED_4_25;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */     uint8_t     FileTimeDate[XFM_FILE_DATE_TIME_BYTE_LENGTH] DEPRECATED_4_25;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */     uint8_t     FileAdditionalComments[XFM_FILE_ADDIT_COMMENT_BYTE_LENGTH] DEPRECATED_4_25;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */     uint8_t 	NumberOfImages DEPRECATED_4_25;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */     uint8_t     Padding[15] DEPRECATED_4_25;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */ } XfmFileHeaderType1_t;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */ #define STID_XFM_FILE_HEADER_TYPE1  MAKE_STRUCTURE_ID(eXfmFileHeaderType1, XfmFileHeaderType1_t)
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */ typedef struct {
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */     uint8_t     Filename[XFM_FILE_FILENAME_BYTE_LENGTH] DEPRECATED_4_25;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */     uint8_t     Size[NUM_BYTES_PER_32BIT_WORD] DEPRECATED_4_25;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */     uint8_t     TimeDate[XFM_FILE_DATE_TIME_BYTE_LENGTH] DEPRECATED_4_25;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */     uint8_t     DeviceSupport[NUM_BYTES_PER_32BIT_WORD] DEPRECATED_4_25;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */     uint8_t     PciBusSupport[NUM_BYTES_PER_32BIT_WORD] DEPRECATED_4_25;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */     uint8_t     VersionNumber[NUM_BYTES_PER_32BIT_WORD] DEPRECATED_4_25;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */     uint8_t     AutomaticSlotAllocation DEPRECATED_4_25;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */     uint8_t     StorageSlot DEPRECATED_4_25;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */     uint8_t 	FpgaAttributes[NUMBER_OF_FPGA_ATTRIBUTES][NUM_BYTES_PER_32BIT_WORD] DEPRECATED_4_25;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */     uint8_t     Padding[6] DEPRECATED_4_25;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */ }FpgaImageHeaderType1_t;
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */ #define STID_FPGA_IMAGE_HEADER_TYPE1  MAKE_STRUCTURE_ID(eFpgaImageHeaderType1, FpgaImageHeaderType1_t)
/* LEGACY SINCE v4.25 - PLEASE IGNORE THIS LINE - SEE DN-0059 */ #endif //NT_LEGACY_4_25

/* NT VPD image info. */
#define VPD_NT_FPGA_IMAGE_BUILD_BY_LENGTH          32
#define VPD_NT_FPGA_IMAGE_CREATED_BY_LENGTH        32
#define VPD_NT_FPGA_IMAGE_NOTE_LENGTH             128
#define VPD_NT_FPGA_IMAGE_FILENAME_LENGTH          64
#define VPD_NT_FPGA_IMAGE_SOURCE_FILENAME_LENGTH   64
#define VPD_NT_FPGA_IMAGE_SOURCE_DATE_TIME_LENGTH  64
#define VPD_NT_FPGA_IMAGE_LOADED_BY_LENGTH         32

typedef struct {
  uint32_t imageNumber;
  uint32_t imageType;
  uint32_t imageVersion;
  uint8_t  imageBuildBy[VPD_NT_FPGA_IMAGE_BUILD_BY_LENGTH];
  uint8_t  imageCreatedBy[VPD_NT_FPGA_IMAGE_CREATED_BY_LENGTH];
  uint8_t  imageNote[VPD_NT_FPGA_IMAGE_NOTE_LENGTH];
  uint8_t  imageFileName[VPD_NT_FPGA_IMAGE_FILENAME_LENGTH];
  uint8_t  imageSourceFileName[VPD_NT_FPGA_IMAGE_SOURCE_FILENAME_LENGTH];
  uint8_t  imageSourceFileDateAndTime[VPD_NT_FPGA_IMAGE_SOURCE_DATE_TIME_LENGTH];
  uint8_t  imageLoadedBy[VPD_NT_FPGA_IMAGE_LOADED_BY_LENGTH];
  uint64_t imageLoadDate;
} FpgaImageHeaderType2_t;

#define STID_FPGA_IMAGE_HEADER_TYPE2 \
    MAKE_STRUCTURE_ID(eFpgaImageHeaderType2, FpgaImageHeaderType2_t)

typedef struct {
   uint32_t ImageNumber;
   uint32_t ImageType;
   uint32_t State;
   uint32_t aData[2];
} FpgaImageStatusType_t;

#define STID_FPGA_IMAGE_STATUS_TYPE \
    MAKE_STRUCTURE_ID(eFpgaImageStatusType, FpgaImageStatusType_t)

#include "ntpackpop.h"

#endif // __NTAPI_FPGAINFOSTRUCTURE_H__
