// $Id: cardinfointerface.h 16051 2011-11-30 12:20:27Z ps $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * This file contains the common types that can be used by any interface.
 */

#ifndef __CARDINFOINTERFACE_H__
#define __CARDINFOINTERFACE_H__

#include "ostype.h"
#include "basetype.h"

#define CARD_INFO_INTERFACE_VERSION        2

typedef struct cardInfonterface
{
	uint16_t size;
	uint16_t version;
	void *context;
  
  NT_STATUS (*GetVersionInfo)(void *context,
                               NTCI_VERSION_INFO * pVersionInfo);

  NT_STATUS (*GetDeviceName)(void     *context, 
                              char     *pNameBuffer,
                              uint32_t MaxBufferLength);

  NT_STATUS (*GetConnectionName)(void     *context,
                                  char     *pNameBuffer,
                                  uint32_t MaxBufferLength);

  NT_STATUS (*GetConnectionGuid)(void     *context,
                                  char     *pNameBuffer,
                                  uint32_t MaxBufferLength);
  NT_STATUS (*GetServiceName)(void     *context,
                               char     *pNameBuffer,
                               uint32_t MaxBufferLength);

  NT_STATUS (*GetPCISlotBusDeviceFunction)(void     *context,
                                            uint32_t *pSBDFIndex);
} CARD_INFO_INTERFACE;


typedef struct cardInfonterfaceV2
{
	uint16_t size;
	uint16_t version;
	void *context;
  
  NT_STATUS (*GetVersionInfo)(void *context,
                               NTCI_VERSION_INFO * pVersionInfo);

  NT_STATUS (*GetDeviceName)(void     *context, 
                              char     *pNameBuffer,
                              uint32_t MaxBufferLength);

  NT_STATUS (*GetConnectionName)(void     *context,
                                  char     *pNameBuffer,
                                  uint32_t MaxBufferLength);

  NT_STATUS (*GetConnectionGuid)(void     *context,
                                  char     *pNameBuffer,
                                  uint32_t MaxBufferLength);
  NT_STATUS (*GetServiceName)(void     *context,
                               char     *pNameBuffer,
                               uint32_t MaxBufferLength);

  NT_STATUS (*GetPCISlotBusDeviceFunction)(void     *context,
                                            uint32_t *pSBDFIndex);

  /* New function. This will in time include all the above functions in terms of
     new STIDs and a V3 will be made. */
  NT_STATUS (*GetCardInfo)(void *context,
                            StructureID idCardInfo,
                            void* cardInfo);
} CARD_INFO_INTERFACE_V2;

#endif // __CARDINFOINTERFACE_H__
