// $Id: lowlevelfilterinterface.h 14206 2011-09-08 16:47:22Z ps $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * This file contains the common types that can be used by any interface.
 */

#ifndef __LOWLEVELINTERFACE_H__
#define __LOWLEVELINTERFACE_H__

#include "ostype.h"
#include "basetype.h"

#define LOWLEVEL_FILTER_INTERFACE_VERSION        1

typedef struct lowlevelFilterInterface
{
	uint16_t size;
	uint16_t version;
	void *context;
	int32_t (*SetFilterDefinitions)( void *context, int channel, 
										uint32_t structId, void *filter);
	int32_t (*SetIndividualFilter)( void *context, 
									   int channel, int filterIndex, 
									   uint32_t structId, void *filter);
	int32_t (*CombineIndividualFilters)( void *context, 
											int channel, int filterIndex, 
											uint32_t structId, void *filter);
	int32_t (*ClearIndividualFilter)( void *context, 
										 int channel, int filterIndex, 
										 uint32_t structId);
} LOWLEVEL_FILTER_INTERFACE;

#endif // __LOWLEVELINTERFACE_H__
