// $Id: prominterface.h 14870 2011-10-13 07:23:23Z bk $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * This file contains the common types that can be used by any interface.
 */

#ifndef INCLUDED_PROMINTERFACE_H
#define INCLUDED_PROMINTERFACE_H
#include <basetype.h>
#include "oswrappertypes.h"
#define PROM_INTERFACE_VERSION        1
typedef struct promInterface
{
	uint16_t size;
	uint16_t version;
	void *context;
	NT_STATUS (*ReadEEPROM)(void *device, 
							 uint32_t deviceId,
							 uint32_t offset,
							 void *data,
							 uint32_t dataLength);

	NT_STATUS (*WriteEEPROM)(void *device, 
							  uint32_t deviceId,
							  uint32_t offset,
							  const void *data,
							  uint32_t dataLength);

	NT_STATUS (*ReadVPDArea)(void *device, 
							  uint32_t deviceId,
							  int offset,
							  void *data,
							  uint32_t dataLength);

	NT_STATUS (*WriteVPDArea)(void *device, 
							   uint32_t deviceId,
							   int offset,
							   const void *data,
							   uint32_t dataLength);

} PROM_INTERFACE;


#endif
