// $Id: statisticsinterface.h 14870 2011-10-13 07:23:23Z bk $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */

/**
 * @file
 * This file contains the common types that can be used by any interface.
 */

#ifndef __STATISTICSINTERFACE_H__
#define __STATISTICSINTERFACE_H__

#include "ostype.h"
#include "basetype.h"

#define STATISTICS_INTERFACE_VERSION        1

typedef struct statisticsInterface
{
	uint16_t size;
	uint16_t version;
	void *context;

	NT_STATUS (*GetStatistics)( void *context,
		uint32_t channel, uint32_t structid, void *data );
	NT_STATUS (*GetIndividualStatistics)( void *context,
		uint32_t channel, uint32_t structid, void *data, uint32_t size );

	NT_STATUS (*ResetStatistics)( void *context, uint32_t channel );

	NT_STATUS (*SetStatisticsOptions)( void *context,
		uint32_t channel, uint32_t structid, void *data );
} STATISTICS_INTERFACE;

#endif // __STATISTICSINTERFACE_H__
