// $Id: ostype.h 22960 2013-03-21 09:15:51Z bk $
/*
 * Copyright 2013 Napatech A/S. All Rights Reserved.
 * 
 *   The source code contained or described herein and all documents
 *   related to the source code ("Material") are owned by Napatech
 *   A/S or its suppliers or licensors.  Title to the Material
 *   remains with Napatech Inc. or its suppliers and licensors. The
 *   software is licensed under the Napatech A/S SCLA License.
 * 
 *   Unless otherwise agreed by Napatech A/S in writing, you may
 *   not remove or alter this notice or any other notice embedded
 *   in Materials by Napatech A/S or Napatech's suppliers or
 *   licensors in any way.
 */
/**
 * @file
 * Simplistic defines used for architecture and os types
 */

#ifndef __OSTYPE_H__
#define __OSTYPE_H__

// Enable below when compiling driver, commonlib and applications for 32bit app support on 64bit platforms.
//#define NT_COMPAT_32BIT 1

// _NT_HOST_CPU_POINTER_SIZE define must be set for commonlib and applications alike! See commonlib makefile.
// Note: Do not alter the _NT_HOST_CPU_POINTER_SIZE result if you use NT_COMPAT_32BIT
#ifndef _NT_HOST_CPU_POINTER_SIZE_32
#define _NT_HOST_CPU_POINTER_SIZE_32 (32)
#define _NT_HOST_CPU_POINTER_SIZE_64 (64)
#endif

#define _NT_OS_TYPE_LINUX        (111)
#define _NT_OS_TYPE_FREEBSD      (555)
#define _NT_OS_TYPE_WIN          (666)

//Enable -Wunused circumvention for backwards compatible function arguments (affix argument with NOUSE)
//Enable deprecated warnings via gcc 
#ifndef NOUSE
#if defined(_MSC_VER) || defined(WIN32) || defined(_WIN64)
    #define NOUSE
    #define DEPRECATED_4_25
    #define WEAK
  #else
    #define NOUSE __attribute__ ((unused))
    #define DEPRECATED_4_25  __attribute__ ((deprecated))   /* Variable/Function has been deprecated since v4.25 (DURHAM). Suppress via -DSUPPRESS_DEPRECATED_LEGACY_4_25_WARNINGS */
  #endif
#endif

//Version specific deprecation warning suppressions
#ifdef SUPPRESS_DEPRECATED_LEGACY_4_25_WARNINGS
#undef DEPRECATED_4_25
#define DEPRECATED_4_25
#endif

#endif // __OSTYPE_H__
