#!/usr/bin/env bash
#
# package_install.sh
#

# check bash
if test -z "${BASH_VERSION}"; then
    echo "You need bash for this script";
    exit;
fi;

#
PLATFORM=`uname | tr "[A-Z]" "[a-z]"`
#
sleep 2
#
echo "[ Extract and build driver ]"
#
cd software
mkdir build
cd build
tar xvfz ../nt_driver_*.tar.gz
cd nt_driver*
cd scripts
sh install.sh -y
#
sleep 2
#
echo "[ Extract, compile and install tools ]"
cd ../../../../tools
mkdir build
cd build
tar xvfz ../nt_tools_*.tar.gz
cd nt_tools*/Tools
sh install.sh
#
sleep 2
#
cd ../../../../pcap
pwd
echo "[ Extract, compile and install Napatech libpcap ]"
cd ../../pcap
do_pcap=0
mkdir build
cd build
tar xvfz ../nt_libpcap_*.tar.gz
cd nt_libpcap_*
do_pcap=1
cd libpcap-1.4.0

if [ "$do_pcap" -eq "1" ]; then
./configure --prefix=/opt/napatech --with-napatech=/opt/napatech napatech_root=/opt/napatech

if [[ "$PLATFORM" != "linux" ]]; then
gmake shared
gmake install
gmake install-shared
else
make shared
make install
make install-shared
fi
ldconfig -f /etc/ld.so.conf
sleep 2
cd ../
fi
#
echo "[ Extract, compile and install applications ]"
cd ../../../applications
mkdir build
cd build
tar xvfz ../nt_applications_*.tar.gz
cd nt_applications_*/Applications
if [ "$do_pcap" -eq "1" ]; then
sh install.sh with-pcap
else
sh install.sh
fi
#
echo "[ Package installation done... ]"
#
